#define PROC
#include "g7to.h"
/* 
 * return after this number of seconds without receiving msg
 */
#define TIMEOUT 2 
#define BAUD_RATE	9600
#define	COM_SETTINGS	(BITS_8 | STOP_1 | NO_PARITY)
#define DISABLE 0
#define ENABLE 1

long	interval;
int	GPSchecksum; 					/* 0=bad, 1=ok */
unsigned char recordtype;		/* record type being sent */
static const double Degree=Pi/180.0;
const	double CONVERT = 11930464.7111111111;	/* 2^31 / 180 */
unsigned valid_records=0;	/* number of valid records in the input file	*/
double	minlat,maxlat,minlon,maxlon;
double  NoProximity=0;		/* number of proximity waypoints found	*/
int	proximity=0;		/* processing a proximity waypoint 	*/
int	doAsyncStat=0;
int	new_com=0;
int	total_dist=0;
int	points=0;		/* No. of track points read from text file */
int	satnum;			/* satellite number for doAlmanac */
int	COMtimeout=0;  		/* Set to 1 on a receiver timeout */
int	gpsposvar=0;
int	gpstimevar=0;
int 	symb=0;			/* set to 1 when reading a symbol from an sa3 file */
int	opterr = 1;		/* argument expansion variable */
int	optind = 1;		/* argument expansion variable */
int	optopt;			/* argument expansion variable */
char	*optarg;		/* argument expansion variable */
int	IOaddr=0x3f8;		/* COM port io address	*/
int	IRQnumber=4;		/* COM port IRQ		*/
int	nocmdline=0;		/* set to 1 if sa3->text is to have command lines */
unsigned validNav=0;		/* we have a valid nav.exe route waypoint	*/
int	firstR=0;		/* used in nav.exe route processing		*/
int	firstW=0;		/* used in nav.exe route processing		*/
int	input=0;		/* we have valid input to process		*/
int	output=0;		/* we have valid output	to process		*/
int	pwr=0;			/* power off to GPS flag			*/

BYTE	m1[]	= "\xfe\x01\x20";	/* Get the model and version number */
BYTE	ack1[]	= "\x06\x02\xff\x00";	/* ack for received mod/ver info */
BYTE	nak1[]	= "\x15\x02\xff\x00";	/* nak for received mod/ver info */
BYTE	p1[]	= "\x06\x02\x1b\x00";	/* Get 1st packet */
BYTE	p2[]	= "\x06\x02\x0c\x00";	/* Get last packet */
BYTE	alm1[]	= "\x0a\x02\x01\x00";	/* Send almanac command */
BYTE	alm2[]	= "\x06\x02\x1f\x00";	/* Get next packet */
BYTE	trk1[]	= "\x0a\x02\x06\x00";	/* Get track command */
BYTE	trk2[]	= "\x06\x02\x22\x00";	/* Get next packet */
BYTE	pwpt1[]	= "\x0A\x02\x03\x00";	/* Get Proximity waypoint command */
BYTE	wpt1[]	= "\x0A\x02\x07\x00";	/* Get waypoint command */
BYTE	wpt2[]	= "\x06\x02\x23\x00";	/* Get next packet */
BYTE	rte1[]	= "\x0a\x02\x04\x00";	/* Get route command */
BYTE	rte2[]	= "\x06\x02\x1d\x00";	/* Get next packet */
BYTE	bgnxfr[]= "\x1b\x02\x00\x00";   /* 0000 filled in with number */
BYTE	almt[]	= "\x0c\x02\x01\x00";	/* Almanac data base terminator */
BYTE	rtet[]	= "\x0c\x02\x04\x00";	/* Route data base terminator */
BYTE	trkt[]	= "\x0c\x02\x06\x00";	/* Track data base terminator */
BYTE	wptt[]	= "\x0c\x02\x07\x00";	/* Waypoint data base terminator */
BYTE	pwroff[]= "\x0a\x02\x08\x00";	/* Power off command */
BYTE	GPStimex[]= "\x0a\x02\x05\x00";	/* send time */
BYTE	GPSPos[]= "\x0a\x02\x02\x00";	/* send position */
BYTE	HDWare[]= "\x0a\x02\x01\x00";	/* send hardware version */

BYTE	gGarminMessage[MAX_LENGTH];
int	lx=0;  /* 1=95lx, 2=100lx */

unsigned char message[MAX_LINE];
unsigned int SWVersion;		/* version * 100 */
char	VersionString[50];	/* model/version in string format */

BYTE newTrack=255;  		/* 255 no track records this session */
                    		/*  0 sending tracks                */
		    		/*  1 sending first track           */

struct RECORD record;

BYTE ok=-1;

int rtnpts[260];
unsigned len;
int tog45=0;			/* 1 = sending data to GPS 45 */
int ComPort=-1;
int AlmanacEOF,RouteEOF,TrackEOF,ProxWaypointEOF,WaypointEOF;
struct PREFS gFilePrefs;
int com_open=0;
BYTE output_format;
struct PREFS gPrefs;

/*
 * Structures
 */
struct ftime ft;
int two=2;
unsigned int filetype;
int latlon=0;
double setlat=0.0;
double setlon=0.0;
double lastlat=0.0;
double lastlon=0.0;

int setmag=0;

int 	Last_ObjCode=-1;
int 	Last_ObjSize=-1;
int 	Last_ObjColor=-1;
int 	Last_TextSize=-1;
int 	Last_TextColor=-1;
int 	Last_TextAlign=-1;

struct sa3symbol {
	unsigned long latR;
	unsigned long lonR;
	int ItemNum;
	unsigned int Const;
	unsigned char paramlen;
	int ObjCode;
	int ObjSize;
	int ObjColor;
	int TextSize;
	int TextColor;
	int TextAlign;
	unsigned char TextLen;
	unsigned char *Text;
	double lat;
	double lon;
} sa3symbol;

struct sa3mapnote {
	unsigned long latR;
	unsigned long lonR;
	int ItemNum;
	unsigned int Const;
	unsigned char paramlen;
	int TextSize;
	int TextColor;
	int TextJustification;
	int TextXoffset;
	int TextYoffset;
	unsigned char TextLen;
	unsigned char *Text;
	double lat;
	double lon;
} sa3mapnote;

struct sa3text {
	unsigned long latR;
	unsigned long lonR;
	int ItemNum;
	unsigned int Const;
	unsigned char paramlen;
	int TextSize;
	int TextColor;
	unsigned char TextLen;
	unsigned char *Text;
	double lat;
	double lon;
} sa3text;

char days[7][4] = {
	"Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat" 
};

char months[13][4] = { "Bad",
	"Jan", "Feb", "Mar", "Apr", "May", "Jun", 
	"Jul", "Aug", "Sep", "Oct", "Nov", "Dec" 
};

unsigned char *genConst;

struct Const2 {
	int a; int b; int c; int d;	
	int e; int f; int g; int h;	
	int i; int j; int k; int l;	
	int m; int n; int o; int p;	
	int q;
	int a1; int a2; int a3; int a4; int a5; int a6;
	int a8; int a9; int aa; int ab; int ac; int ad;
	int ae; int af; int ag; int ah; int ai; int aj;
	int ak; int al; int am; int an; int ao; int ap;
	int aq; int ar; int as; int at; int au; int av;
	int aw; int ax; int ay; int az; int ba; int bb;
	int bc; int bd;
	char qqa;
	char qqa1[9];
	char qq;
	char qq1[9];
	int be; int bf;
} Const2 = {
	0,0,0,0x3ff0,
	0,0,0,0,
	0,0,0,0,
	0,0,0,0x3ff0,
	0x7fff,
	1,1,0,0,10000,10000,
	1,1,6500,6500,9700,9700,
	1,1,200,200,9700,800,
	1,1,0,0,7500,10000,
	1,1,7500,0,10000,10000,
	1,1,200,200,7200,800,
	4,1,
	9,"chain.chn",
	9,"chain.chn",
	1,1
};

struct Const3 {
	int a; int b; int c; int d;
} Const3 = {
	0,5,0x200,0x766c
};

struct Const4 {
	int a; int b; int c;
	int d; int e; int f;
	int i; int h; int g;
	int j;
} Const4 = {
	1,0x3fff,0,
	3,0,1,
	1,0x3fff,0,
	0x100
};

struct Trailer {
	int a; int b; int c;
	int d; int e; int f;
	int i; int h;
} Trailer = {
	3,0,1,
	1,0x3fff,0,
	0x100,0
};

/*
 * global variables
 */
FILE *in;
FILE *out;
FILE *merge;
FILE *tempf;

char tf[80];		/* temp file used in G45->routes.clg	*/
char fname_in_txt[80]; 	/* input file, gd7/txt			*/
char fname_in_SA3[80];	/* input file, SA3			*/
char fname_in_NAV[80];	/* input file, Navigate routes.clg	*/
char fname_o_SA3[80];	/* output file -- s3			*/
char fname_o_NAV[80];	/* Navigate Routes file routes.clg	*/
char sa_mergename[80];	/* SA3 merge file			*/

int g45type=0;		/* 1=Tracks,  2=Waypoints, 3=Routes	*/
			/* 4=iD,      5=tIme,      6=Position	*/
			/* 7=Almanac, 8=proXimity waypoints     */

int intype=0;		/* input type 1=txt/gd7 2=G45 3=SA3		*/
			/*            4=almanac data  5=Navigate route	*/
unsigned numrecords;	/* number of input records in file	*/
unsigned numtracks;	/* number of track records in file	*/
unsigned numwaypoints;	/* number of waypoint records in file	*/
int firstwaypoint=1;
int firstPwaypoint=1;
int firsttrackpoint=1;

char *p;		/* general pointer for string functions	*/
char buf[255];		/*  general string			*/

unsigned long LatConst=0x6ae187b1L;
unsigned long LonConst=0x494ae39bL;
double LatC,LonC;

int sa3number=0;  /* number of waypoints and or track points read from file */
int Id=0x100,MagC=4,Mapfeatures=0x3fff;

char *MapTitle;
int nameonly=0, noname=0;
int ShowGrids=1, NumObjs;
int ObjColor=0,TextColr=0,TextSize=0,ObjSize=0,TextAlign=2;
int ItemType,Item,ObjCode=12; /* small circle */
unsigned char MtLen;
unsigned char TextLen;
unsigned long Const1=0x1a2b3c4dL;
unsigned char *ItemText;

/*
 * date of co-ordinant
 */
char unsigned bin[255];
char fmode[10];
int optchar;
int navmode=0,		/* 1 = navigate.exe output	*/
    tmode=0,		/* 1 = text output desired	*/
    g6=0,	 	/* 1 = garmin64 output		*/
    i80=0,		/* 1 = control point *80* record */
    p4=0,		/* 1 = proj output desired	*/
    s3o=0,		/* 1 = output is sa3 file	*/
    sa_merge=0;		/* 1 = merging sa3,sa3 to sa3	*/

#define START 2447892L /* Julian date for 00:00 12/31/89 */

char align[8][3]={"nw","n","ne","w","e","sw","s","se"};
char sizes[5][3]={"vs","s","m","l","vl"};
char colors[5][7]={"black","red","blue","green","yellow"};


double track_d=0.0;
double sum_dist=0.0;

PROC double distance(void)
{
	double d1, dx, dy, lo;
	lo = -record.lo;
	d1 = cos((lastlat + record.la)/2.0*Degree);
	dy = (record.la - lastlat)*60.0;
	dx = (lo - lastlon)*60.0*d1;
	return sqrt(dy*dy + dx*dx);
} /* distance */

PROC void chk_cmdline(void)
{
	if(nocmdline) return;
	if(Last_ObjCode==sa3symbol.ObjCode     &&
	   Last_ObjSize==sa3symbol.ObjSize     &&
	   Last_ObjColor==sa3symbol.ObjColor   &&
	   Last_TextSize==sa3symbol.TextSize   &&
	   Last_TextColor==sa3symbol.TextColor &&
	   Last_TextAlign==sa3symbol.TextAlign ) return;
	printf("! -b %d -c o%s -c t%s -s o%s -s t%s -a o%s\n",
		     sa3symbol.ObjCode,
                     colors[sa3symbol.ObjColor],
                     colors[sa3symbol.TextColor],
		     sizes[sa3symbol.ObjSize],
		     sizes[sa3symbol.TextSize],
	             align[sa3symbol.TextAlign]);
	Last_ObjCode=sa3symbol.ObjCode;
	Last_ObjSize=sa3symbol.ObjSize;
	Last_ObjColor=sa3symbol.ObjColor;
	Last_TextSize=sa3symbol.TextSize;
	Last_TextColor=sa3symbol.TextColor;
	Last_TextAlign=sa3symbol.TextAlign;
} /* chk_cmdline */

/* dt is the date and time in the format "Wed Apr 10 hh:mm:ss 1996" and secs
   is the number of seconds since 12/31/1989 00:00:00, as defined by the
   #define START
*/
/* -------------------------------------------------------------------------- */
PROC char *secs2dt(long secs, short offset)
{
	static char dt[50];

	long daysn = (secs + (long)(offset*3600.0)) / 86400L;
	long rem = secs + (long)(offset*3600.0) - daysn *  86400L;
	if(rem<0L) rem=-rem; /* saw it once, don't know what it ment */
	
	days2date(daysn,(short*)&record.monthn,
		        (short*)&record.dayofmonth,
		        (short*)&record.year);

	strcpy(record.day_week,
	               days[dow(record.dayofmonth,record.monthn,record.year)]);
	strcpy(record.month,months[record.monthn]);

	record.ht = (int)(rem/3600L);
	record.mt = (int)((rem-(long)record.ht*3600L)/60L);
	record.st = (int)((rem-(long)record.ht*3600L)-(long)record.mt*60L);

	sprintf(dt, "%s %s %02d %02d:%02d:%02d %04d", 
			days[dow(record.dayofmonth,record.monthn,record.year)],
			months[record.monthn], 
			record.dayofmonth, record.ht, record.mt, record.st,
			record.year);

	return dt;
} /* secs2dt */

/* -------------------------------------------------------------------------- */
PROC long dt2secs(short offset)
{
	return 86400L * date2days(record.monthn,
				record.dayofmonth,
				record.year)      +
			  3600L * (long)record.ht + 
			  60L * (long)record.mt   +
			  (long)record.st         -
			  (long)(offset*3600.0);
} /* dt2secs */

/* -------------------------------------------------------------------------- */
PROC long date2days(short mm, short dd, short yy)
{
	long jul;
	short ja, jy, jm;
	
	if (yy < 0)
		++yy;
	if (mm > 2) {
		jy = yy;
		jm = mm + 1;
	}
	else {
		jy = yy - 1;
		jm = mm + 13;
	}
	ja = .01 * jy;
	jul = (long)(floor(365.25 * jy) + floor(30.6001 * jm) +
				(long)dd + 1720997L - (long)ja +
				(long)(0.25 * (long)ja));

	return jul-START;
} /* date2days */

/* -------------------------------------------------------------------------- */
PROC void days2date(long days, short *mm, short *dd, short *yy)
{
	long ja, jalpha, jb, jc, jd, je;

	jalpha = ((float)(days+START-1867216L)-0.25)/36524.25;
	ja = days+START+1+jalpha-(long)(0.25*jalpha);

	jb = ja + 1524L;
	jc = 6680.0 + ((double)(jb - 2439870L) - 122.1) / 365.25;
	jd = 365.25 * jc;
	je = (jb - jd) / 30.6001;
	*dd = jb - jd - (short)(30.6001 * je);
	*mm = je - 1;
	if (*mm > 12)
		*mm -= 12;
	*yy = jc - 4715;
	if (*mm > 2)
		--(*yy);
	if (*yy <= 0)
		--(*yy);
} /* days2date */

/* -------------------------------------------------------------------------- */
/*
 * Converts a latitude passed in as DDD.dddddddd to the string
 *
 *    NDDD MM.SSSS which is returned by the function.
 *
 *  This routine also sets the elements dla, mla, tnthsla, minla and secla
 *   in the record 'record'.
 */
PROC char *toDMlat(double a)
{
	static char dm[15];
	double frac, ttt;
	char mm[15];
	double d;

	if(a<0.0) {
		record.ns='S'; /* 'W' and 'S' are negative when data is from 	*/
		a=fabs(a);     /* the G45					*/
	}
	else    record.ns='N';
	frac=modf(a,&d);
	record.minla=frac*60.0;
	record.secla=60.0*modf(record.minla,&ttt);

	sprintf(mm, "%c%02.0f %07.4f", record.ns, d, record.minla);
	strcpy(dm,mm);
	record.dla=atoi(strtok(&mm[1]," "));
	record.mla=atoi(strtok(NULL,"."));
	record.tnthsla=atoi(&mm[7]);
	return dm;
} /* toDMlat */

/* -------------------------------------------------------------------------- */
/*
 * Converts a longitude passed in as DDD.dddddddd to the string
 *
 *    WDDD MM.SSSS which is returned by the function.
 *
 *  This routine also sets the elements dlo, mlo, tnthslo, minlo and seclo
 *   in the record 'record'.
 */
PROC char *toDMlon(double a)
{
	static char cm[15];
	double frac, ttt;
	char mm[15];
	double d;

	if(a<0.0) {
		record.ew='W'; /* 'W' and 'S' are negative when data is from 	*/
		a=fabs(a);     /* the G45					*/
	}
	else      record.ew='E';
	frac=modf(a,&d);
	record.minlo=frac*60.0;
	record.seclo=60.0*modf(record.minlo,&ttt);

	sprintf(mm, "%c%03.0f %07.4f", record.ew, d, record.minlo);
	strcpy(cm,mm);
	record.dlo=atoi(strtok(&mm[1]," "));
	record.mlo=atoi(strtok(NULL,"."));
	record.tnthslo=atoi(&mm[8]);
	return cm;
} /* toDMlon */

/*
 * exits closing COM port if necessary
 */
PROC void byebye(int rt)
{
	if(com_open) {
		if(doAsyncStat) doasystat();
		AsyncStop();
	}
	if(lx==2) light_sleep(ENABLE);
	if(COMtimeout) printf("GPS Receiver not responding.\n");
	delay(100);
	exit(rt);
} /* byebye */

/*
 * converts string DEGdMMmmmm to deg.decimal
 */
PROC double mhr(char * tt)
{
	char *p;
	double h,m;
	double sign;

	strupr(tt);
	if((h=atof(tt))<0.0) {
		h=fabs(h);
		sign=-1.0;
	}
	else sign=1.0;
	p=strtok(tt,"D");
	p=strtok(NULL,"");
	m=atof(p);

	return sign*(h+m/60.0);
} /* mhr */

/*
 * remove interior spaces, make sure all chars are A-Z 0-9 '-'
 */
PROC void fixname(int j,unsigned char *name)
{
	int i;

	trim((char*)name);
	strupr((char*)name);
	for(i=0;i<strlen((char*)name);i++) {
		if(name[i]==0x0d || name[i]==0x10) name[i]=' ';
		if(name[i]==0x27) name[i]='M';
		if(name[i]==0xb0) name[i]='D';
		if(!j && name[i]==' ') name[i]='-';
		if(!((name[i]>='A' && name[i] <='Z') || 
		     (name[i]>='0' && name[i] <='9') ||
		     (name[i]==' '))) name[i]='-';
	}
} /* fixname */

/*0123456789012345678921234567893123456789412345678951234567896123456789712345*/
/*W  HOME   N44 35.8936 W123 15.5252 Wed Dec 20 08:24:38 1995 764 NW BEAVER PL*/
PROC void print_text_w(void)
{
	char bfr[150],bfr1[30];

	if(symb==1) chk_cmdline();
	fixname(0,(BYTE *)record.name);
	record.comment[16]=0;
	if(tmode) {
		if(g45type==1) {
			printf("T  ");
		}
		else {
			if(proximity) printf("P  %-6s ",record.name);
			else printf("W  %-6s ",record.name);
		}
	}
	if(navmode && g45type==3) if(proximity)
	                                  fprintf(tempf,"P  %-6s ",record.name);
					else 
					  fprintf(tempf,"W  %-6s ",record.name);
	if(tmode) printf("%c%#02d %#02d.%#04d %c%#03d %#02d.%#04d ",
		record.ns,record.dla,record.mla,record.tnthsla,record.ew,
		record.dlo,record.mlo,record.tnthslo);
	if(navmode && g45type==3)
		fprintf(tempf,"%c%#02d %#02d.%#04d %c%#03d %#02d.%#04d ",
		record.ns,record.dla,record.mla,record.tnthsla,record.ew,
		record.dlo,record.mlo,record.tnthslo);

	sprintf(bfr,"%3s %3s %02d %02d:%02d:%02d %4d %-16s",
		days[dow(record.dayofmonth,record.monthn,record.year)],
		months[record.monthn],record.dayofmonth, record.ht,
		record.mt, record.st, record.year, record.comment);
	if(proximity) {
		sprintf(bfr1," %4.1f",record.ProxDist);
		strcat(bfr,bfr1);
	}
	trim(bfr);
	if(tmode) printf("%s\n",bfr);
	if(navmode && g45type==3) fprintf(tempf,"%s\n",bfr);
} /* print_text_w */

/*
 * trims leading blanks
 */
PROC char *ltrim(char *s)
{
	register char *p;

	p=s;
	while((*p)==' ') p++;
	strcpy(s,p);
	return(s);
}
/*
 * Strips trailing blanks from the string
 */
PROC char *rtrim(char *s)
{
	register int i;

	if(!(i=strlen(s))) return(s);
	i--;
	while((s[i]==' ') && (i>=0)) s[i--]='\0';
	return(s);
}
/*
 * converts the newline character (0x0a) to a NUL (0x00) in a char array
 */
PROC char *null_newline(char *s)
{
	register int i;
	if(!(i=strlen(s))) return(s);
	i--;
	while(i>=0) {
		if(s[i]==0x0a) s[i]=0;
		i--;
	}
	return(s);
} /* null_newline */

/*
 * Strips leading and trailing blanks from the string.
 */
PROC char *trim(char *s)
{
	ltrim(s);
	rtrim(s);
	return(s);
}

PROC int decode_month(char *s)
{
	int i;
	for(i=1;i<13;i++) if(!strcmp(s,months[i])) return(i);
	return(0);
} /* decode_month */

/*0123456789012345678921234567893123456789412345678951234567896123456789712345*/
/*W  HOME   N44 35.8936 W123 15.5252 Wed Dec 20 08:24:38 1995 764 NW BEAVER PL*/
PROC void fill_record(unsigned char *ix)
{
	char mm[150];

/*
 * adjust Track ascii record 
 */
	if(ix[0]=='T') {
		sprintf(mm,"T         %s",(char*)&ix[3]);
	}
	else strcpy(mm,(char*)ix);
	if(strlen(mm) <= 35) {
		mm[34]=0;
		strcat(mm," Wed Dec 20 08:24:38 1995");
	}
	strncpy((char*)record.name,(char*)&mm[3],6);
	record.name[6]=0;
	if(strlen((char*)mm)>60) strcpy(record.comment,(char*)&mm[60]);
	if(mm[0]=='P') {
		record.ProxDist = (float)atof(&mm[77]);
	}
	record.comment[17]=0;
	strncpy(record.datetime,(char*)&mm[35],24);
	record.datetime[24]=0;
/*
 * decode latitude
 */
	p=(char*)&mm[11];
	record.dla=atoi(strtok(p," "));
	record.mla=atoi(strtok(NULL,"."));
	record.tnthsla=atoi(strtok(NULL," "));
	record.minla=(double)record.mla+record.tnthsla/10000.0;
	record.secla=(double)record.tnthsla*60.0/10000.0;
	record.la=(double)record.dla+record.minla/60.0;
	record.ns=mm[10];
/*
 * decode longitude
 */
	p=(char*)&mm[23];
	record.dlo=atoi(strtok(p," "));
	record.mlo=atoi(strtok(NULL,"."));
	record.tnthslo=atoi(strtok(NULL," "));
	record.minlo=(double)record.mlo+record.tnthslo/10000.0;
	record.seclo=(double)record.tnthslo*60.0/10000.0;
	record.lo=(double)record.dlo+record.minlo/60.0;
	record.ew=mm[22];
/*
 * get month, day, year, hours, minutes
 */
 	strncpy((char*)buf,(char*)&mm[39],3);
	buf[3]=0;
 	record.monthn=decode_month(buf);
	p=(char*)&mm[43];
	record.dayofmonth=atoi(strtok(p," "));
	p=(char*)&mm[55];
	record.year=atoi(strtok(p," "));
	p=(char*)&mm[46];
	record.ht=atoi(strtok(p,":"));
	record.mt=atoi(strtok(NULL,":"));
	record.st=atoi(strtok(NULL," "));
} /* fill_record */

/* D  100	WGS 84  */
/*01234567890123456789...*/
/*R  01 ANYTOWN OR  */
PROC int decode_route_start(unsigned char *ix)
{
	char in[150];

	strcpy(in,(char*)ix);
	if((in[0] != 'R') || (in[1] != ' ') || (in[2] != ' ')) return(-1);
	record.in_route=1;
	strcpy(record.rtn,strtok((char*)&in[3]," "));
	record.route_number=atoi(strtok((char*)&in[3]," "));
	strcpy(record.route_comment,(char*)&in[6]);
	return(0);
} /* decode_route_start */

/*012345678901234...*/
/*E  01  */
PROC void decode_route_end(unsigned char *in)
{
	if((in[0] != 'E') || (in[1] != ' ') || (in[2] != ' ')) return;
	record.in_route=0;
} /* decode_route_end */

PROC void print_g64_w()
{
	fixname(0,(BYTE *)record.name);
	record.comment[20]=0;
	if(record.in_route) {
		printf("%#02d ",record.route_number);
	}
      printf("%-6s %#03d%c%06.3lf%c%c %#03d%c%06.3lf%c%c %#02d-%#02d-%#02d %#02d:%#02d %-16s",
      record.name, record.dla,0xb0,record.minla,0x27,record.ns,
      record.dlo,0xb0,record.minlo,0x27,record.ew,record.year-1900,
      record.monthn,record.dayofmonth, record.ht,record.mt,record.comment);
      if(record.in_route) printf(" %-20s",record.route_comment);
      putchar('\n');
} /* print_g64_w */

PROC void print_g64_t()
{
	printf("%#03d%c%06.3lf%c%c %#03d%c%06.3lf%c%c %#02d-%#02d-%#02d %#02d:%#02d\n",
	  record.dla,0xb0,record.minla,0x27,record.ns,
	  record.dlo,0xb0,record.minlo,0x27,record.ew,record.year-1900,
	  record.monthn,record.dayofmonth,record.ht,record.mt);
} /* print_g64_t */

PROC void print_proj_w()
{
	fixname(0,(BYTE *)record.name);
	record.comment[19]=0;
	printf("%#03dd%#02d'%08.5lf\"%c %#02dd%#02d'%08.5lf\"%c %#02d-%#02d-%#02d %#02d:%#02d %-6s %-19s",
	 record.dlo,record.mlo,record.seclo,record.ew,record.dla,record.mla,
	 record.secla,record.ns,record.year,record.monthn,record.dayofmonth,
	 record.ht,record.mt,record.name,record.comment);
	if(record.in_route) {
		printf("R:%#02d ",record.route_number);
		printf(" %-20s",record.route_comment);
	}
	putchar('\n');
} /* print_proj_w */

PROC void print_proj_t()
{
	printf("%#03dd%#02d'%08.5lf\"%c %#02dd%#02d'%08.5lf\"%c %#02d-%#02d-%#02d %#02d:%#02d\n",
	        record.dlo,record.mlo,record.seclo,record.ew,
	        record.dla,record.mla,record.secla,record.ns,record.year,
		record.monthn,record.dayofmonth,record.ht,record.mt);
} /* print_proj_t */

/*
 * prints the data from a waypoint--after processed-into a Control Point Record
 *  (IE a *80* record) for use with the program utms.exe
 */
/*       1         2         3         4         5         6         7     
1234567890123456789012345678901234567890123456789012345678901234567890123456789
SeqNum*80*srn StationName...................DDMMSSsssssNDDDMMSSsssssWEEEEee*/
PROC void print_x80_w()
{
	char strla[15];
	char strlo[15];
	int ssla,sslo;
	long frla,frlo;

	fixname(0,(BYTE *)record.name);

	record.comment[23]=0;
	sprintf(strla,"%#8.5lf",record.secla);
	ssla=atoi(strtok(strla,"."));
	frla=atol(strtok(NULL," "));

	sprintf(strlo,"%#8.5lf",record.seclo);
	sslo=atoi(strtok(strlo,"."));
	frlo=atol(strtok(NULL," "));

 printf("%-6s*80*%3s %-6s %-23s%#02d%#02d%#02d%#05ld%c%#03d%#02d%#02d%#05ld%c\n"
	," ",(record.in_route==1)?record.rtn:" ",record.name,record.comment,
	 record.dla,record.mla,ssla,frla,record.ns,record.dlo,record.mlo,sslo,
	 frlo,record.ew);
} /* print_x80_w */

/*       1         2         3         4         5         6         7     
1234567890123456789012345678901234567890123456789012345678901234567890123456789
SeqNum*80*srn StationName...................DDMMSSsssssNDDDMMSSsssssWEEEEee*/
PROC void print_x80_t()
{
	char strla[15];
	char strlo[15];
	int ssla,sslo;
	long frla,frlo;

	sprintf(strla,"%#8.5lf",record.secla);
	ssla=atoi(strtok(strla,"."));
	frla=atol(strtok(NULL," "));

	sprintf(strlo,"%#8.5lf",record.seclo);
	sslo=atoi(strtok(strlo,"."));
	frlo=atol(strtok(NULL," "));

   printf("%-6s*80*%-3s %-30s%#02d%#02d%#02d%#05ld%c%#03d%#02d%#02d%#05ld%c\n",
          " ", " ",record.datetime,record.dla,record.mla,ssla,frla,record.ns,
	  record.dlo,record.mlo,sslo,frlo,record.ew);

} /* print_x80_t */

/* 
          Control Point Record (IE: *80* record) **
 
01234567890123456789012345678901234567890123456789012345678901234567890123456789
         1         2         3         4         5         6         7     
1234567890123456789012345678901234567890123456789012345678901234567890123456789
SeqNum*80*srn StationName...................DDMMSSsssssNDDDMMSSsssssWEEEEee

    CC01-06   Sequence Number                                (OPTIONAL)
    CC07-10   Data Code (IE: *80*)
    CC11-13   Station Serial Number                          (OPTIONAL)
    CC14      Blank
    CC15-44   Station Name
    CC45-55   Geodetic Latitude: Deg-Min-Sec, to 5 decimal places,
              decimal point implied between CC50-51 (DDMMSSsssss)
    CC56      Direction of Latitude:  N or S
    CC57-68   Geodetic Longitude: Deg-Min-Sec, to 5 decimal places,
              decimal point implied between CC63-64 (DDDMMSSsssss)
    CC69      Direction of Longitude:  E or W
    CC70-75   Elevation of mark above MSL, in meters, decimal
              point implied between CC73-74 (EEEEee)         (OPTIONAL)
    CC76      Elevation code                                 (OPTIONAL)
    CC77-78   State or Country Code                          (OPTIONAL)
    CC79-80   Station Order and Type                         (OPTIONAL)
 */
PROC void x80(unsigned char *s)
{
	switch (s[0]) {
		case 'W': print_x80_w(); break; 
		case 'T': print_x80_t(); break; 
	}
} /* x80 */

PROC void g64(unsigned char *s)
{
	switch (s[0]) {
		case 'W': print_g64_w(); break; 
		case 'T': print_g64_t(); break; 
	}
} /* g64 */

PROC void proj(unsigned char *s)
{
	switch (s[0]) {
		case 'W': print_proj_w(); break; 
		case 'T': print_proj_t(); break; 
		case 'D': printf("# Input datum was: %s\n",s); break;
	}
} /* proj */

/*
 * output a waypoint read from gardown7 file or text file to
 *  a SA3 file.  NOT used during a merge of SA3 files
 */
PROC void sa3out_w(void)
{
	sa3symbol.ItemNum=sa3number++;

	sa3symbol.latR=to_diskLL((double)record.dla +
	                         ((double)record.mla/60.0) +
		                 record.secla/3600.0);
	sa3symbol.lonR=to_diskLL((double)record.dlo +
	                         ((double)record.mlo/60.0) +
		                 record.seclo/3600.0);

	if(sa3symbol.Text != NULL) free(sa3symbol.Text);
	sa3symbol.Const=0x8000;
	sa3symbol.paramlen=0;
	sa3symbol.ObjCode=ObjCode;
	sa3symbol.ObjSize=ObjSize;
	sa3symbol.ObjColor=ObjColor;
	sa3symbol.TextSize=TextSize;
	sa3symbol.TextColor=TextColr;
	sa3symbol.TextAlign=TextAlign;
	sa3symbol.Text=(unsigned char *)calloc(strlen((char*)record.name)+
	                                       strlen(record.comment)+5,1); 

	if(noname) {
		sa3symbol.Text[0]=0;
	}
	else {
		if(bin[0]=='T') {
			sprintf((char*)sa3symbol.Text,"%-6d",sa3number);
		}
		else {
			sprintf((char*)sa3symbol.Text,"%-6s",record.name);
			if(!nameonly)  {
				strcat((char*)sa3symbol.Text," ");
				strcat((char*)sa3symbol.Text,record.comment);
			}
		}
	}
	sa3symbol.TextLen=strlen((char*)sa3symbol.Text);
/*
 * output the record to the sa3 file
 */
	fwrite(&two,2,1,out);
	fwrite(&sa3symbol,26,1,out);
	fwrite(sa3symbol.Text, sa3symbol.TextLen,1,out);
} /* sa3out_w */

PROC void read_COM(void)
{
	time_t t;

	int c;

	switch(g45type) {
		case 1: getTrack(); break;
		case 2: getWaypoints(); break;
		case 3: getRoute(); break;
		case 4: getID(); break;
		case 5: getGPSTime(); break;
		case 6: if(!interval) {
				getGPSPosition();
				getGPSTime();
			}
			else {
				getGPSPosition();
				getGPSTime();
				while(1) {
					t=time(NULL);
					while(time(NULL)-t < interval) {
						c=kbraw();
						if(c=='x' || c=='X') return;
					}
					getGPSPosition();
					getGPSTime();
				}
			}
			break;
		case 7: getAlmanac(); break;
		case 8: getProxWaypoints(); break;
		default: printf("Unknown GPS-45 read function\n"); byebye(-1);
	}
} /* read_COM */

PROC int read_sa3_header(FILE *in, char* fname_in)
{
 	fread(&Id,2,1,in);
	if(Id!=0x100) {
		printf("File %s is not a valid DeLorme .SA3 file\n",fname_in);
		byebye(0);
	}
 	fread(&Const1,4,1,in);
/*
 * get map title length
 */
 	fread(&MtLen,1,1,in);
/*
 * get map title
 */
 	if(MapTitle != NULL) free(MapTitle);
 	MapTitle=(char *)malloc(MtLen+1);
 	fread(MapTitle,MtLen,1,in);

	MapTitle[MtLen]=0;
/*
 * get map center co-ords
 */
 	fread(&LatConst,4,1,in);
	LatC=fm_diskLL(LatConst);
 	fread(&LonConst,4,1,in);
	LonC=fm_diskLL(LonConst);
	fread(&MagC,2,1,in);
 	fread(&Const2,134,1,in);
 	fread(&Mapfeatures,2,1,in);
 	fread(&Const3,8,1,in);
 	fread(&ShowGrids,2,1,in);
	fread(&Const4,20,1,in);
	fread(&NumObjs,2,1,in);
	return(NumObjs);
} /* read_sa3_header */

/*
 * decode a Waypoint or Track record from a gardown7 file or a text
 *  file and output it to the open sa3 output file.  
 *  NOT used during a merge of SA3 files.  Called only by read_text.
 */
PROC void sa3out(unsigned char *s)
{
	switch (s[0]) {
		case 'W': sa3out_w(); break;
		case 'T': sa3out_w(); break; 
	}
} /* sa3out */

/*
 *  process an input command line
 */
PROC void do_command(unsigned char *b)
{
	int i,j;
	char *p;
	char *argv[40];  /* allow 40 elements on the command line */

	opterr=0;
	p=strtok((char*)b," ");
	argv[0]=malloc(strlen(p)+2);
	strcpy(argv[0],p);
	i=1;	
	while (p!=NULL) {
		if((p=strtok(NULL," ")) == NULL) break;
		argv[i]=malloc(strlen(p)+2);
		strcpy(argv[i],p);
		i++;
	}
	optind=1;
	while ((optchar=getopt(i,argv,"a:A:b:B:c:C:s:S:")) != -1) {
	     switch(optchar) {
	    	case 'a':
		case 'A':	set_align(); break;

		case 'b':
		case 'B': 	ObjCode=atoi(optarg); break;

	    	case 'c':
		case 'C':	set_color(); break;

	    	case 's':
		case 'S':	set_size(); break;

	     }
	}
	for(j=0;j<i;j++) free(argv[j]);
	opterr=1;
} /* do_command */

/*
044x35.863'N 123x15.426'W 1996-04-14 20:17           x=0xB0
0123456789012345678921234567893123456789412345678951234567896123456789712345
DUMMY  044x35.866'N 123x15.328'W 1996-04-14 20:17    x=0xB0
1ST-B  044x34.000'N 123x16.030'W 95-12-07 03:55 07-DEC-95 03:55
0123456789012345678921234567893123456789412345678951234567896123456789712345
W  YAQHED N44 40.5217 W124 04.6048 Mon Mar 25 15:28:04 1996 YAQUINA HEAD
*/
PROC void convert_g64(unsigned char *in)
{
	unsigned char bx[150];
	int i,offset=0;
	int mm,dd,yy;

	for(i=0;i<150;i++) bx[i]=0;
	i=strlen((char*)in);
	if(in[3]!=0xb0) offset=7;
	if(offset) {
		strcpy((char*)bx,"W  ");
		strncat((char*)bx,(char*)(in),6);
	}
	else strcpy((char*)bx,"T        ");
	strcat((char*)bx," ");
	bx[10]=in[offset+11];
	strncat((char*)bx,(char*)(in+offset+1),10);
	bx[13]=' '; bx[20]='0';
	bx[21]=' '; bx[22]=in[offset+24];
	strncat((char*)bx,(char*)(in+offset+13),11);
	bx[26]=' '; bx[33]='0'; bx[34]=' ';
	yy=atoi(strtok((char*)(in+offset+26),"-"));
	mm=atoi(strtok(NULL,"-"));
	dd=atoi(strtok(NULL," "));
	strcat((char*)bx,days[dow(dd,mm,yy)]);
	strcat((char*)bx," ");
	strcat((char*)bx,months[mm]);
	strcat((char*)bx," ");
	strncat((char*)bx,(char*)(in+offset+32),2);  /* day */
	strcat((char*)bx," ");
	strncat((char*)bx,(char*)(in+offset+35),5);  /* hr:mm */
	strcat((char*)bx,":00 19");
	strncat((char*)bx,(char*)(in+offset+26),2);
	if(offset && i>50) strcat((char*)bx,(char*)(in+47));
	if(bx[0]=='T') strcpy((char*)(bx+3),(char*)(bx+10));
	strcpy((char*)in,(char*)bx);
	trim((char*)in);
} /* convert_g64 */

/*
124d04'36.28800"W 44d40'31.30200"N 1996-03-25 15:28 YAQHED YAQUINA HEAD       
0123456789012345678921234567893123456789412345678951234567896123456789712345
W  YAQHED N44 40.5217 W124 04.6048 Mon Mar 25 15:28:04 1996 YAQUINA HEAD
*/
PROC void convert_proj(unsigned char *in)
{
	unsigned char mm[150];
	unsigned char name[99];
	unsigned char clo[9];
	unsigned char cla[9];
	unsigned char comment[40];
	unsigned char hhmm[7];
	int dla;
	double secla,mla;
	int dlo;
	double seclo,mlo;
	int mmm,dd,yy;
	unsigned char *p;

	strcpy((char*)mm,(char*)in);
	trim((char*)mm);
	dlo=atoi(strtok((char*)mm,"d"));
	mlo=atof(strtok(NULL,"'"));
	seclo=atof(strtok(NULL,"\""));
	strcpy((char*)clo,strtok(NULL,"\t "));
	dla=atoi(strtok(NULL,"d"));
	mla=atof(strtok(NULL,"'"));
	secla=atof(strtok(NULL,"\""));
	strcpy((char*)cla,strtok(NULL,"\t "));
	if(strlen((char*)in)>35) {
		yy=atoi(strtok(NULL,"-"));
		mmm=atoi(strtok(NULL,"-"));
		dd=atoi(strtok(NULL,"\t "));
		strcpy((char*)hhmm,strtok(NULL,"\t "));
		strcpy((char*)name,trim((char*)p=strtok(NULL,"\t ")));
		if((char*)p==NULL) name[0]=0;
		if(strlen((char*)name) > 6 ) {
			strcpy((char*)comment,(char*)&name[6]);
			strcat((char*)comment," ");
		}
		else comment[0]=0;
		strcat((char*)comment,trim((char*)p=strtok(NULL,"x")));
		if((char*)p==NULL) comment[0]=0;
		name[6]=0;
		comment[16]=0;
		strupr((char*)name);
		strupr((char*)comment);
	}
	else {
		yy=1989;
		mmm=1;
		dd=1;
		strcpy((char*)hhmm,"00:00");
		name[0]=0;
		comment[0]=0;
	}
  sprintf((char*)in,
           "W  %-6s %c%02d %07.4lf %c%03d %07.4lf %3s %3s %02d %s:00 %4d %-16s",
		(char*)name,cla[0],dla,mla+secla/60.0,clo[0],dlo,mlo+seclo/60.0,
		days[dow(dd,mmm,yy)], months[mmm], dd, (char*)hhmm, yy,
		(char*)comment
		);
	/* assume a track point, not a waypoint */
	if(comment[0]==0 && name[0]==0) {
		in[0]='T';
		strcpy((char*)(in+3),(char*)(in+10));
	}
	trim((char*)in);
} /* convert_proj */

PROC void read_text(void)
{
	int i;

	while(fgets((char*)bin,255,in) != NULL) {
		null_newline((char*)bin);
		trim((char*)bin);
		if(bin[0]=='!') {
			do_command(bin);
			continue;
		}
		i=strlen((char*)bin);
/*
 * strip gardown 7 junk from waypoints
 */
		if(bin[i-1]==0xff || bin[i-1]==0x7f) bin[i-1]=0;
		if(!strlen((char*)bin)) continue;
		if(bin[3]=='d' && bin[15]=='"') convert_proj(bin);
		if((bin[3] ==0xb0 && bin[16]==0xb0) ||
		   (bin[10]==0xb0 && bin[23]==0xb0)) convert_g64(bin);
		if(bin[1]!=' ' || bin[2]!=' ') continue;
		valid_records++;
		if(bin[0] == 'R') {
			decode_route_start(bin); 
			if(tmode) printf("%s\n",bin);
			if(tog45) doSRoute();
			if(navmode) {
				navSRouteS();
				validNav++;
			}
			continue;
		}
		if(bin[0] == 'E') {
			decode_route_end(bin); 
			if(tmode) printf("%s\n",bin);
			if(tog45) {
				sendGPSMessage(rtet, 4);
				(void)getGPSMessage();
			}
			continue;
		}
		if(bin[0]=='N' && total_dist) {
			if(points!=0) {
			    if(points>1) {
			      printf(" Dist: %7.3lf nm, %7.3lf sm, %7.3lf km\n",
			         track_d,track_d*1.15078,track_d*1.852);
			      sum_dist+=track_d;
			      track_d=0.0;
			    }
			    points=0;
			}
		}
		if(tmode) printf("%s\n",bin);
		if((bin[0]=='T' || bin[0]=='W') || (bin[0]=='P')) {
			lastlat=record.la;
			lastlon=-record.lo;
			fill_record(bin);
			if(bin[0]!='P') 
				if(total_dist && ++points>1)
					track_d+=distance();
		}
		if(i80) x80(bin);
		if(g6) g64(bin);
		if(p4) proj(bin);
		if(s3o) sa3out(bin);
		if(tog45) {
			if(bin[0]=='W') doSWaypoint(0);
			if(bin[0]=='P') doSWaypoint(1);
			if(bin[0]=='T') doSTrack();
			if(bin[0]=='N') newTrack=1;
			if(bin[0]=='D') continue; /* skip datum */
		}
		if(navmode) 
			if(bin[0]=='W')
				navSWaypoint();
	}
	if(valid_records==0) printf("No valid records found in file %s\n",
			fname_in_txt);
	if(total_dist) {
		sum_dist+=track_d;
		if(points>1)
			printf(" Dist: %7.3lf nm, %7.3lf sm, %7.3lf km\n",
			        track_d,track_d*1.15078,track_d*1.852);
		printf(" DSum: %7.3lf nm, %7.3lf sm, %7.3lf km\n",
			sum_dist, sum_dist*1.15078, sum_dist*1.852);
	}
} /* read_text */

PROC double fm_diskLL(unsigned long l)
{
	unsigned long ff7f,m80;

	ff7f=0x7fffffL;
	m80=0x80000000L;

	return (m80-l)/(double)ff7f;

} /* fm_diskLL */

PROC unsigned long to_diskLL(double l)
{
	unsigned long ff7f,m80;

	ff7f=0x7fffffL;
	m80=0x80000000L;

	return (unsigned long)(m80 - (unsigned long)(l*(double)ff7f));
} /* to_diskLL */

/*
 * output a MapNote record during a merge of SA3 files
 */
PROC void out_sa3_m(void)
{
	sa3mapnote.ItemNum=sa3number++;
/*
 * output the first part of the record to the sa3 file
 */
	fwrite(&ItemType,2,1,out);
	fwrite(&sa3mapnote,13,1,out);
	if(sa3mapnote.paramlen) fwrite(genConst,sa3mapnote.paramlen,1,out);
/*
 * rest of record
 */
	fwrite(&sa3mapnote.TextSize,11,1,out);
	fwrite(sa3mapnote.Text, sa3mapnote.TextLen,1,out);
} /* out_sat_m */

/*
 * output a Symbol record during a merge of SA3 files
 */
PROC void out_sa3_s(void)
{
	sa3symbol.ItemNum=sa3number++;
/*
 * output the record to the sa3 file
 */
	fwrite(&ItemType,2,1,out);
	fwrite(&sa3symbol,13,1,out);
	if(sa3symbol.paramlen) fwrite(genConst,sa3symbol.paramlen,1,out);
	fwrite(&sa3symbol.ObjCode,13,1,out);
	fwrite(sa3symbol.Text, sa3symbol.TextLen,1,out);
} /* out_sa3_s */

/*
 * output a Text record during a merge of SA3 files
 */
PROC void out_sa3_t(void)
{
	sa3text.ItemNum=sa3number++;
/*
 * output the record to the sa3 file
 */
	fwrite(&ItemType,2,1,out);
	fwrite(&sa3text,13,1,out);
	if(sa3text.paramlen) fwrite(genConst,sa3text.paramlen,1,out);
	fwrite(&sa3text.TextSize,5,1,out);
	fwrite(sa3text.Text, sa3text.TextLen,1,out);
} /* out_sa3_t */

PROC void readText(FILE *in)
{
	fread(&sa3text,13,1,in);
	if(sa3text.paramlen) {
		if(genConst!=NULL) free(genConst);
		genConst=(unsigned char *)malloc(sa3text.paramlen+1);
		fread(genConst,sa3text.paramlen,1,in);
	}
/*
 * read rest of text
 */
	fread(&sa3text.TextSize,5,1,in);

	sa3text.lat=fm_diskLL(sa3text.latR);
	sa3text.lon=fm_diskLL(sa3text.lonR);

	record.type='W'; /* waypoints for all for now */
	if(sa3text.Text != NULL) free(sa3text.Text);
 	sa3text.Text=(unsigned char *)malloc(sa3text.TextLen+1);
	fread(sa3text.Text,sa3text.TextLen,1,in);
	sa3text.Text[sa3text.TextLen]=0;
	if(!sa_merge) {
		(void)toDMlat(sa3text.lat); sa3text.lat=fabs(sa3text.lat);
		(void)toDMlon(sa3text.lon); sa3text.lon=fabs(sa3text.lon);
		fixname(1,sa3text.Text);
		sprintf(record.name,"%-6s",sa3text.Text);
		record.name[6]=0;
		if(sa3text.TextLen>7)
			strcpy(record.comment,(char*)&sa3text.Text[7]);
		else
			strcpy(record.comment," ");

		if(sa3text.lon<0.0) record.ew='E';
		else record.ew='W';

		if(p4) print_proj_w();
		if(g6) print_g64_w();
		if(i80) print_x80_w();
		if(tmode) print_text_w();
	}
	else out_sa3_t();
} /* readText */

PROC void readSymbol(FILE *in)
{
	symb=1;
	fread(&sa3symbol,13,1,in);
	if(sa3symbol.paramlen) {
		if(genConst!=NULL) free(genConst);
		genConst=(unsigned char *)malloc(sa3symbol.paramlen+1);
		fread(genConst,sa3symbol.paramlen,1,in);
	}
/*
 * read rest of symbol
 */
	fread(&sa3symbol.ObjCode,13,1,in);
	sa3symbol.lat=fm_diskLL(sa3symbol.latR);
	sa3symbol.lon=fm_diskLL(sa3symbol.lonR);

	record.type='W'; /* waypoints for all for now */
	if(sa3symbol.Text != NULL) free(sa3symbol.Text);
 	sa3symbol.Text=(unsigned char *)malloc(sa3symbol.TextLen+1);
	fread((char*)sa3symbol.Text,sa3symbol.TextLen,1,in);
	sa3symbol.Text[sa3symbol.TextLen]=0;
	if(!sa_merge) {
		(void)toDMlat(sa3symbol.lat); sa3symbol.lat=fabs(sa3symbol.lat);
		(void)toDMlon(sa3symbol.lon); sa3symbol.lon=fabs(sa3symbol.lon);
		fixname(1,sa3symbol.Text);
		record.name[6]=0;
		sa3symbol.Text[6]=0;
		strncpy((char *)record.name,(char *)sa3symbol.Text,6);
		if(sa3symbol.TextLen>7)
			strcpy(record.comment,(char*)&sa3symbol.Text[7]);
		else
			strcpy(record.comment," ");
		if(sa3symbol.lon<0.0) record.ew='E';
		else record.ew='W';

		if(p4) print_proj_w();
		if(g6) print_g64_w();
		if(i80) print_x80_w();
		if(tmode) print_text_w();
	}	
	else out_sa3_s();
	symb=0;
} /* readSymbol */

PROC void readMapNote(FILE *in)
{
	fread(&sa3mapnote,13,1,in);
	if(sa3mapnote.paramlen) {
		if(genConst!=NULL) free(genConst);
		genConst=(unsigned char *)malloc(sa3mapnote.paramlen+1);
		fread(genConst,sa3mapnote.paramlen,1,in);
	}
/*
 * read rest of mapnote
 */
	fread(&sa3mapnote.TextSize,11,1,in);

	sa3mapnote.lat=fm_diskLL(sa3mapnote.latR);
	sa3mapnote.lon=fm_diskLL(sa3mapnote.lonR);

	record.type='W'; /* waypoints for all for now */
	if(sa3mapnote.Text != NULL) free(sa3mapnote.Text);
 	sa3mapnote.Text=(unsigned char *)malloc(sa3mapnote.TextLen+1);
	fread(sa3mapnote.Text,sa3mapnote.TextLen,1,in);
	sa3mapnote.Text[sa3mapnote.TextLen]=0;
	if(!sa_merge) {
	     (void)toDMlat(sa3mapnote.lat); sa3mapnote.lat=fabs(sa3mapnote.lat);
	     (void)toDMlon(sa3mapnote.lon); sa3mapnote.lon=fabs(sa3mapnote.lon);
		if(strlen((char*)sa3mapnote.Text)>=40) sa3mapnote.Text[40]=0;
		if(strlen((char*)sa3mapnote.Text)>=6) sa3mapnote.Text[6]=0;
		fixname(0,sa3mapnote.Text);
		fixname(1,(sa3mapnote.Text+7));
		if(sa3mapnote.paramlen) {
			sprintf((char*)record.name,"MN%-4d",++latlon);
			strcpy(record.comment,(char*)sa3mapnote.Text);
		}
		else {
			sprintf(record.name,"%-6s",sa3mapnote.Text);
			if(sa3mapnote.TextLen>7)
			      strcpy(record.comment,(char*)&sa3mapnote.Text[7]);
			else
			      strcpy(record.comment," ");
		}
		record.name[6]=0;

		if(sa3mapnote.lon<0.0) record.ew='E';
		else record.ew='W';

		if(p4) print_proj_w();
		if(g6) print_g64_w();
		if(i80) print_x80_w();
		if(tmode) print_text_w();
	}	
	else out_sa3_m();
} /* readMapNote */

PROC void read_sa3(FILE *in)
{
	int i;
	int nr=0; /* pseudo waypoint name for uploading from SA3 file */
/*
 * Start reading Items here
 */
	for(i=1;i<=NumObjs;i++) {
		fread(&ItemType,2,1,in);
		switch(ItemType) {
			case 1: readText(in); break;
			case 2: readSymbol(in); break;
			case 3: readMapNote(in); break;
			default: printf("Found a new SA3 Item: %d\n",ItemType);
				byebye(4);
		}
		if(tog45) {
			if(strlen(trim(record.name))==0) {
				sprintf(record.name,"%-6d",++nr);
			}
			doSWaypoint(0);
		}
	}
} /* read_sa3 */

PROC void UsagehD(void)
{
  printf("                   -- OBJECTS --\n");
  printf("Size     : vs, s, m, l, vl\n");
  printf("Alignment: nw, n, ne, w, e, sw, s, se\n");
  printf("Color    : black, red, blue, green and yellow\nCodes for use with -b:\n");
  printf(" 0 = Agricultural                            35 = One Way Up\n");
  printf(" 1 = Airport        18 = Education           36 = Park\n");
  printf(" 2 = Amusement      19 = Emergency           37 = Parking\n");
  printf(" 3 = Arrow, Down    20 = Fishing             38 = Phone\n");
  printf(" 4 = Arrow, Left    21 = Fuel                39 = Picnic\n");
  printf(" 5 = Arrow, Right   22 = Golf Course         40 = Post Office\n");
  printf(" 6 = Arrow, Up      23 = Government Building 41 = Power\n");
  printf(" 7 = Bank           24 = Historic Site       42 = Religious Star\n");
  printf(" 8 = Beach          25 = Home                43 = Religious Cross\n");
  printf(" 9 = Boat Ramp      26 = Industrial          44 = Restaurant\n");
  printf("10 = Campground     27 = Information         45 = Sports\n");
  printf("11 = Cemetary       28 = Library             46 = Square\n");
  printf("12 = Circle         29 = Lodging             47 = Star\n");
  printf("13 = Construction   30 = Mountain            48 = State Capitol\n");
  printf("14 = Cross          31 = National capitol    49 = Stop Sign\n");
  printf("15 = Delivery Stop  32 = One Way Down        50 = Triangle Down \n");
  printf("16 = Diamond        33 = One Way Left        51 = Triangle Up\n");
  printf("17 = Doctor/Dentist 34 = One Way Right       52 = Zoo\n");
  byebye(0);
} /* UsagehD */

PROC void Usageh0(void)
{
	printf("GPS45 Upload/Download/File Conversion 2.06 %s %s PST\n\n",__DATE__,__TIME__);
	printf("USAGE:g7to -123 -d -v -h -i infile -p68t [-abceswnm -o outfile | >outtext]\n");
	printf("\nFor more information:\n");
	printf("-h I for input help\n");
	printf("-h O for output help\n");
	printf("-h D for SA3 symbol attributes\n\n");
	printf("-d sum Track distances if source is GPS45 or Text file\n");
	printf("-v print stats for COM port\n");
	byebye(0);
} /* Usageh0 */

PROC void UsagehI()
{
 printf("\nAllowable Input files:\n  SA3, text, [Proj, Garmin64 (Waypoint/Track only)], route.clg or GPS45\n\n");
 printf("Use -1 or -2 to set standard COM Port 1-2\n\n");
 printf("  To specify the port parameters use:\n");
 printf("  -3 Port,IOaddr,IRQ (no spaces allowed) where:\n");
 printf("     Port is 1-4, IOaddr in hex (0xnnn) or decimal, IRQ (3-15) decimal\n");
 printf("\n  g7to -3 1,0x3f8,4       defines a standard COM1 port\n\n");
 printf("Use:\n");
 printf("    -i G45Pn -- Send Time/Position record every n seconds (press 'x' to stop)\n");
 printf("    -i G45A  -- Send Almanac data\n");
 printf("    -i G45I  -- Send current time\n");
 printf("    -i G45D  -- Send software ID\n");
 printf("    -i G45R  -- Send Routes (output cannot be SA3)\n");
 printf("    -i G45T  -- Send Tracks (-d to sum distances)\n");
 printf("    -i G45W  -- Send Waypoints\n");
 printf("    -i G45X  -- Send Proximity Waypoints\n\n");
 printf("    -e Do not print symbol attributes to text file\n");
 printf("            (SA3 input, text out only)\n");
 byebye(0);
} /* UsagehI */

PROC void UsagehO()
{
 printf("Output can be to SA3 file or the GPS45 (-o G45) and stdout\n");
 printf("  -o G45O turns off the GPS45\n");
 printf("-----------------------------------------------------------------\n");
 printf(" -o <fname> - name for Street Atlas 3.0 file\n");
 printf("   -a,-b,-c,-g,-l,-m,-n,-s,-w used with .sa3 output only\n");
 printf("    a - Text alignment:  NW N NE W E SW S SE\n");
 printf("    b - Object Code.  Values 0-52 see G7TO.DOC\n");
 printf("    c - ?color ?=T for Text color, O for Object Color\n");
 printf("        Allowable colors: black,red,blue,green,yellow\n");
 printf("    g - map magnitude\n");
 printf("    l - 1st-center map Lat|2nd-center map Long (DDdMM.mmmm)\n");
 printf("    m - Merge -i (SA3 file) and -m (SA3 file) to -o (SA3 file)\n");
 printf("    n - No name and no description\n");
 printf("    s - ?size ?=T for Text size, O for Object size\n");
 printf("        Allowable sizes: vs,s,m,l,vl\n");
 printf("    w - Waypoint name only, no description\n");
 printf(" -r - Navigate.exe Route file, routes.clg\n");
 printf("-----------------------------------------------------------------\n");
 printf("or stdout (can re-direct to a text file)\n");
 printf("  T - Text Format\n");
 printf("  P - Proj.4.3.3 Record    (proj.exe, nad2nad.exe)\n");
 printf("  6 - Garmin64 Format      (garmin.exe)\n");
 printf("  8 - Control Point Record (utms.exe)\n");
 byebye(0);
} /* UsagehO */

PROC void Usage(int i)
{
	if(!opterr) return;
	switch(i) {
		case 1: printf("Bad color input\n"); break;
		case 2: printf("Color must have 'T' or 'O' as first character\n"); break;
		case 3: printf("Bad size input\n"); break;
		case 4: printf("Size must have 'T' or 'O' as first character\n"); break;
		case 5: printf("Alignment must be NW N NE W E SW S or SE\n"); break;
		case 7: printf("Object code must be 0-52\n"); break;
		case 9: printf("Invalid COM port specification\n");break;
		case 11: printf("Input file must be specified\n"); break;
		case 12: printf("Both input and output cannot be sa3 unless merging\n");break;
		case 14: printf("Program error #1\n"); break;
		case 15: printf("COM Port must 1-4\n");break;
		case 16: printf("Route number > 99, aborting\n");break;
		case 17: printf("The only G45 input allowed for -r is g45r\n");
			 break;
	}
	byebye(0);
} /* Usage */

/***********************************************************************
 *
 *          int  dow( int iDay, int iMon, int iYear ) - This is my
 *             implementation of the Zeller function.  It takes day/
 *             month/year and returns the day of the week as an int
 *             with Sunday being 0.....etc.
 ******/
PROC int dow( int day, int mon, int year )
{
   int adj_mo, adj_yr, cent, cent_yrs;
 
   adj_mo = ( mon > 2 ) ? mon - 2 : mon + 10;
   adj_yr = ( mon > 2 ) ? year    : year - 1;
   cent = adj_yr / 100;
   cent_yrs = adj_yr % 100;
   return((((( 13 * adj_mo - 1 ) / 5 ) + day + cent_yrs +
             ( cent_yrs / 4 ) + ( cent / 4 ) - 2 * cent + 77 ) % 7 ));
} /* dow */
/*
 * parse MYID record
 */
PROC void doID(void)
{
	BYTE *x;  
	unsigned *p;
	x=&gGarminMessage[2]; 			/* data length */
	p=(unsigned *)&gGarminMessage[5];
	SWVersion=*p;
	strncpy(VersionString,(char *)&gGarminMessage[7],*x-4);
	trim(VersionString);
	printf("%s\n",VersionString);
} /* doID */

PROC void doEOFRec(void)
{
	AlmanacEOF=RouteEOF=TrackEOF=ProxWaypointEOF=WaypointEOF=0;
	switch(gGarminMessage[3]) {
		case 1: AlmanacEOF=1; break;
		case 3: ProxWaypointEOF=1;break;
		case 4: RouteEOF=1; break;
		case 6: TrackEOF=1; break;
		case 7: WaypointEOF=1; break;
		default: break;
	}
} /* doEOFRec */

PROC void doTime(void)
{
	record.year=*((int*)(gGarminMessage+5));
	record.monthn=(int)gGarminMessage[3];
	record.dayofmonth=(int)gGarminMessage[4];
	record.ht=(int)gGarminMessage[7];
	record.mt=(int)gGarminMessage[9];
	record.st=(int)gGarminMessage[10];
	printf("%s \n", secs2dt(dt2secs(0), gPrefs.offset));
} /* doTime */

PROC void doGPSPos(void)
{
	record.la = *((double*)(gGarminMessage+3))/Degree;
	record.lo = *((double*)(gGarminMessage+11))/Degree;
	printf("T  %s %s ",toDMlat(record.la),toDMlon(record.lo));
} /* doGPSPos */

/* -------------------------------------------------------------------------- */
#if 0
/* Garmin message type characters			*/
#define ACK	0x06	/* last record received was ok	*/
#define ALM 	0x1f	/* Almanac record		*/
#define EOFREC  0x0c	/* EOF leadin for transters	*/
#define GPSpos	0x11	/* GPS Position record		*/
#define PROX  	0x13	/* Proximity Waypoint record	*/
#define MYID	0xff	/* Version/ID record		*/
#define NAK	0x15	/* last record received was bad */
#define NREC	0x1b	/* number of records to receive */
#define RTE_NAM 0x1d	/* Route name record		*/
#define RTE_WPT 0x1e	/* Route waypoint record	*/
#define TIMEREC 0x0e	/* UTC Time record 		*/
#define TRK 	0x22	/* Track record			*/
#define WPT 	0x23	/* Waypoint record		*/
#endif

PROC void parseGPS(void)
{
	switch (gGarminMessage[1]) {

		case EOFREC:
			doEOFRec();
			break;
		
		case RTE_NAM:	/* Route name record */
			doRouteName();
			break;

		case RTE_WPT:	/* Route waypoint record */
			doWaypoint();
			break;

		case ALM:		/* Almanac record */
			doAlmanac();
			break;

		case TRK:		/* Track record */
			doTrack();
			break;

		case PROX:		/* Waypoint record */
			doProxWaypoint();
			break;

		case WPT:		/* Waypoint record */
			doWaypoint();
			break;
		case MYID:		/* Version/ID record */
			doID();
			break;

		case ACK:
			ok=1;
			break;
		case NAK:
			ok=0;
			break;
		case NREC:
			numrecords=*((unsigned*)(gGarminMessage+3));
			break;
		case TIMEREC:
			doTime();
			gpstimevar=1;
			break;
		case GPSpos:
			doGPSPos();
			gpsposvar=1;
			break;
		default:
			break;
	}
} /* parseGPS */

/* -------------------------------------------------------------------------- */

PROC void doRouteName()
{
	if(record.in_route==1 && tmode)
		printf("E  %02d\n",record.route_number);
	if(record.in_route==1 && navmode && g45type==3)
		fprintf(tempf,"E  %02d\n",record.route_number);
	record.in_route=1;
	record.route_number=*(gGarminMessage+3);
	sprintf(record.rtn,"%02d",record.route_number);
	strncpy(record.route_comment,(char*)(gGarminMessage+4),20);
	if(tmode)
	     printf("R  %02d %s\n",record.route_number,record.route_comment);
	if(navmode && g45type==3) fprintf(tempf,"R  %02d %s\n",record.route_number,record.route_comment);
} /* doRouteName */

/* -------------------------------------------------------------------------- */

PROC void doTrack()
{
	if (*(gGarminMessage+15) == '\x01') {/* New track */
		if(total_dist && points>1) {
			printf(" Dist: %7.3lf nm, %7.3lf sm, %7.3lf km\n",
				track_d, track_d*1.15078, track_d*1.852);
			points=0;
			sum_dist+=track_d;
			track_d=0.0;
		}
		if (numrecords != 0) {
			if(tmode) printf("N  New Track Start\n");
		}
	}
   	record.la=((double)(*((long*)(gGarminMessage+3)))/CONVERT);
	record.lo=((double)(*((long*)(gGarminMessage+7)))/CONVERT);
	if(total_dist) { 
		if(++points>1) track_d+=distance();
	}
	(void)toDMlat(record.la);
	(void)toDMlon(record.lo);
	secs2dt(*((long*)(gGarminMessage+11)) , gPrefs.offset);

	if(p4) print_proj_t();
	if(g6) print_g64_t();
	if(i80) print_x80_t();
	if(tmode) print_text_w();
	if(s3o) {
		bin[0]='T';
		sa3out_w();
	}
} /* doTrack */
PROC void send_num_points(unsigned num)
{
	int ret;
/*
 * send number of route waypoint records to send
 */
	*((short*)(bgnxfr+2)) = num;
	ret=0;
	do {
		ret++;
		sendGPSMessage(bgnxfr, 4);
		(void)getGPSMessage();	/* make sure GPS receiver responded */
		if(COMtimeout) byebye(0);
		parseGPS();
	} while(ok!=1 && ret<=7);
	if(ret>7) {
		printf("Too many NAKS in send_num_points\n");
		byebye(-1);
	}
} /* send_num_points */
/*
 * Send a waypoint to the GPS
 * Returns a result code--zero if GPS receiver did not respond
 */
PROC void doSWaypoint(int prox)
{
	short ret;int i;
/*
 * first waypoint?  Then send number to send if known
 */
 	if(prox==0) {
		if(firstwaypoint&&!record.in_route)
			send_num_points(numwaypoints);
		firstwaypoint=0;
	}
	if(prox==1) {
		if(firstPwaypoint&&!record.in_route)
			send_num_points(NoProximity);
		firstPwaypoint=0;
	}
	for(ret=0;ret<60;ret++) message[ret]=' ';

	if(record.ns=='S') i=-1; else i=1;
	*((long*)(message+8))  = (long)(i * record.la * CONVERT);

	if(record.ew=='W') i=-1; else i=1;
	*((long*)(message+12)) = (long)(i * record.lo * CONVERT);

	if (record.in_route) /* type == ROUTE */
		message[0] = '\x1e';
	else {
		if(prox) message[0] = '\x13';
		else     message[0] = '\x23';
	}
	
	if(prox==0) message[1] = 58;	/* number of message bytes to follow */
	if(prox==1) message[1] = 62;

	fixname(0,(BYTE*)record.name);
	for(ret=0;ret<6;ret++) if(record.name[ret]==0) record.name[ret]=0x20;
	strncpy((char*)message+2, record.name,6);

	*((long*)(message+16)) = dt2secs(gFilePrefs.offset);

	strcpy((char*)message+20, record.comment);
	if(prox) {
		*((float*)(message+60)) = record.ProxDist;
	}
	ret=0;
	do {
		ret++;
		if(prox==0) sendGPSMessage(message, 60);
		else sendGPSMessage(message, 64);
		i=getGPSMessage();	/* make sure GPS receiver responded */
		if(COMtimeout) byebye(0);
		parseGPS();
	} while(ok!=1 && ret<=7);
	if(ret>7) {
		printf("Too many NAKS in doSWaypoint\n");
		byebye(-1);
	}
} /* doSWaypoint */

/* ----------------------------------------------------------- */
PROC void doSTrack()
{
	int ret,i;

	if(firsttrackpoint) send_num_points(numtracks);
	firsttrackpoint=0;
	for(ret=0;ret<60;ret++) message[ret]=' ';

	if(record.ns=='S') i=-1; else i=1;
	*((long*)(message+2)) = (long)(i * record.la * CONVERT);

	if(record.ew=='W') i=-1; else i=1; 
	*((long*)(message+6)) = (long)(i * record.lo * CONVERT);

	message[0] = '\x22';
	message[1] = 13;	/* number of message bytes to follow */

	*((long*)(message+10)) = dt2secs(gFilePrefs.offset);

	if(newTrack==255) newTrack=1;
	message[14] = newTrack;		/* new track flag */
	newTrack = 0;
	ret=0;
	do {
		ret++;
		sendGPSMessage(message, 15);
		i=getGPSMessage();	/* make sure GPS receiver responded */
		if(COMtimeout) byebye(0);
		parseGPS();
	} while(ok!=1 && ret<=7);
	if(ret>7) {
		printf("Too many NAKS in doSTrack\n");
		byebye(-1);
	}
} /* doSTrack */

/* -------------------------------------------------------------------------- */
/* Returns a result code--zero if GPS receiver did not respond */
/*
 *  When sending route data the sequence is:
 *
 *  1.  Send 'Route/ID' record.  Read the responding ACK/NAK
 *  2.  Send 'Number of records to follow' record, Read ACK/NAK
 *  3.  Send each waypoint in the route as a route waypoint record and
 *       read each ACK/NAK
 *  4.  Send 'Route end of database record'.  Read ACK/NAK
 * 
 */
PROC void doSRoute()
{
	short i;
	int ret;
/*
 * send number of route waypoint records to send +1 for the route name
 */
	*((short*)(bgnxfr+2)) = rtnpts[record.route_number]+1;
	ret=0;
	do {
		ret++;
		sendGPSMessage(bgnxfr, 4);
		i=getGPSMessage();	/* make sure GPS receiver responded */
		if(COMtimeout) byebye(0);
		parseGPS();
	} while(ok!=1 && ret<=7);
	if(ret>7) {
		printf("Too many NAKS in doSRoute\n");
		byebye(-1);
	}
/*
 * send route ID record
 */
	for(i=3;i<23;i++) message[i]=' ';
	message[0] = '\x1d';
	message[1] = 21;
	message[2] = record.route_number;
	fixname(1,(BYTE*)record.route_comment);
	strcpy((char*)message+3, record.route_comment);
	for(i=3;i<23;i++) if(message[i]==0) message[i]=' ';
	message[19]=0;
	ret=0;
	do {
		ret++;
		sendGPSMessage(message, 23);
		i=getGPSMessage();	/* make sure GPS receiver responded */
		if(COMtimeout) byebye(0);
		parseGPS();
	} while(ok!=1 && ret<=7);
	if(ret>7) {
		printf("Too many NAKS in doSRoute sending route number/name\n");
		byebye(-1);
	}
} /* doSRoute */

/*
 * called from read_text when output is to nav.exe route file and
 *  input line is a route waypoint
 */
PROC void navSRouteS(void)
{
	int i,Numr=0;
	unsigned int xx=0xffff, z=0, fo=4;
	char mm[5]="CRte";
	unsigned char len;

	if(firstR==0) {
		for(i=0;i<260;i++) if(rtnpts[i]>0) Numr++;
		fwrite(&Numr,2,1,out);
		fwrite(&xx,2,1,out);
		fwrite(&z,2,1,out);
		fwrite(&fo,2,1,out);
		fwrite(mm,4,1,out);
		firstR++;
	}
	else {
		z=0x8001;
		fwrite(&z,2,1,out);
	}
	len=strlen(record.route_comment);
	fwrite(&len,1,1,out);
	fwrite(record.route_comment,len,1,out);
	fwrite(&rtnpts[record.route_number],2,1,out);
	
} /* navSRouteS */

PROC void navSWaypoint(void)
{
	unsigned int xx=0xffff, z=0, fo=4;
	char mm[5]="CWpt";
	unsigned char len;
	double t;
	long ll, lo;

	t=record.la; ll=(long)(t*60000.0);
	if(record.ns=='S') ll=-ll;
	t=record.lo; lo=(long)(t*60000.0);
	if(record.ew=='E') ll=-ll;
	if(firstW==0) {
		fwrite(&xx,2,1,out);
		fwrite(&z,2,1,out);
		fwrite(&fo,2,1,out);
		fwrite(mm,4,1,out);
		firstW++;
	}
	else {
		z=0x8003;
		fwrite(&z,2,1,out);
	}
	trim(record.name);
	len=strlen(record.name);
	fwrite(&len,1,1,out);
	fwrite(record.name,len,1,out);
	trim(record.comment);
	len=strlen(record.comment);
	fwrite(&len,1,1,out);
	fwrite(&record.comment,len,1,out);
	fwrite(&ll,4,1,out);
	fwrite(&lo,4,1,out);

} /* navSWaypoint */

/* -------------------------------------------------------------------------- */
PROC void doWaypoint()
{
	extern struct PREFS gPrefs;

	record.la = ((double)(*((long*)(gGarminMessage+9)))/CONVERT);
	record.lo = ((double)(*((long*)(gGarminMessage+13)))/CONVERT);

	(void)toDMlat(record.la);
	(void)toDMlon(record.lo);
	if(total_dist) { 
		if(++points>1) track_d+=distance();
	}
/*
 * waypoint name
 */
	strncpy(record.name,(char*)&gGarminMessage[3],6);
/*
 * Date/Time
 */
        secs2dt(*((long*)(gGarminMessage+17)),gPrefs.offset);
/*
 * Comment, up to 40 characters
 */
	strncpy(record.comment,(char*)&gGarminMessage[21],40);
	if(p4) print_proj_w();
	if(g6) print_g64_w();
	if(i80) print_x80_w();
	if(tmode || (navmode && g45type==3)) print_text_w();
	if(s3o) {
		bin[0]='W';
		sa3out_w();
	}
} /* doWaypoint */

/* -------------------------------------------------------------------------- */
PROC void doProxWaypoint()
{
	extern struct PREFS gPrefs;

	proximity=1;

	record.la = ((double)(*((long*)(gGarminMessage+9)))/CONVERT);
	record.lo = ((double)(*((long*)(gGarminMessage+13)))/CONVERT);

	(void)toDMlat(record.la);
	(void)toDMlon(record.lo);
	if(total_dist) { 
		if(++points>1) track_d+=distance();
	}
/*
 * waypoint name
 */
	strncpy(record.name,(char*)&gGarminMessage[3],6);
/*
 * Date/Time
 */
        secs2dt(*((long*)(gGarminMessage+17)),gPrefs.offset);
/*
 * Comment, up to 40 characters
 */
	strncpy(record.comment,(char*)&gGarminMessage[21],40);
/*
 * Proximity distance
 */
	record.ProxDist = *((float*)&gGarminMessage[61]);

	if(p4) print_proj_w();
	if(g6) print_g64_w();
	if(i80) print_x80_w();
	if(tmode || (navmode && g45type==3)) print_text_w();
	if(s3o) {
		bin[0]='P';
		sa3out_w();
	}
	proximity=0;
} /* doProxWaypoint */

struct alm {
	int wk;		/* Week       -1 if poor health */
	float ta;	/* Time of Applicability(s)	*/
	float af0;	/* Af0(s)			*/
	float af1;	/* Af1(s)			*/
	float ecc;	/* Eccentricity			*/
	float sqrta;	/* SQRT(A)  (m^1/2)		*/
	float meananom;	/* Mean Anom(rad)		*/
	float argper;	/* Argument of Perigee(rad)	*/
	float RA;	/* Right Ascen at TOA(rad)	*/
	float RRA;	/* Rate of Right Ascen(r/s)	*/
	float OI;	/* Orbital Inclination(rad)	*/
} *almm;

struct alm *alm;

/* -------------------------------------------------------------------------- */
PROC void doSAlmanac()
{
/*
 * we assume all 32 satellites.  The GPS45 does not have a method
 *  for inputting the satellite number....
 */
 	int ret=0;
	int sending=0,id,hold,health;
 	char lb[150];

	almm=(struct alm*)(message+2);

	*((short*)(bgnxfr+2)) = 32;
	do {
		ret++;
		sendGPSMessage(bgnxfr,4);  /* send # sats */
		len=getGPSMessage();	/* make sure GPS receiver responded */
		if(COMtimeout) byebye(0);
		parseGPS();
	} while(ok!=1 && ret<=7);
	if(ret>7) {
		printf("Too many NAKS in doSAlmanac\n");
		byebye(-1);
	}

	while(fgets((char*)lb,255,in) != NULL) { /* get first line */
		sending++;
		fgets(lb,255,in);	/* ID */
		id=atoi(&lb[25]);
		fgets(lb,255,in);	/* Health (also in week# for Garmin) */
		health=atoi(&lb[25]);

		fgets(lb,255,in);	/* ecc */
		almm->ecc=(float)atof(&lb[25]);

		fgets(lb,255,in);	/* ta */
		almm->ta=(float)atof(&lb[25]);

		fgets(lb,255,in);	/* OI */
		almm->OI=(float)atof(&lb[25]);

		fgets(lb,255,in);	/* rra */
		almm->RRA=(float)atof(&lb[25]);

		fgets(lb,255,in);	/* sqrta */
		almm->sqrta=(float)atof(&lb[25]);

		fgets(lb,255,in);	/* RA */
		almm->RA=(float)atof(&lb[25]);

		fgets(lb,255,in);	/* argper */
		almm->argper=(float)atof(&lb[25]);

		fgets(lb,255,in);	/* meananom */
		almm->meananom=(float)atof(&lb[25]);

		fgets(lb,255,in);	/* af0 */
		almm->af0=(float)atof(&lb[25]);

		fgets(lb,255,in);	/* af1 */
		almm->af1=(float)atof(&lb[25]);

		fgets(lb,255,in);	/* wk */
		almm->wk=atoi(&lb[25]);

		fgets(lb,255,in);	/* blank line */
		if(health!=0)
			hold=-1;
		else 
			hold=almm->wk;
		almm->wk=-1;
		message[0]=0x1f; message[1]=0x2a;
		while(sending != id) { /* sending dummy */
			ret=0;
			do {
				ret++;
				sendGPSMessage(message, 44);
				len=getGPSMessage();
				if(COMtimeout) byebye(0);
				parseGPS();
			} while(ok!=1 && ret<=7);
			if(ret>7) {
				printf("Too many NAKS in doSAlmanac\n");
				byebye(-1);
			}
			sending++;
		}
		almm->wk=hold;	
		ret=0;
		do {
			ret++;
			sendGPSMessage(message, 44);
			len=getGPSMessage();
			if(COMtimeout) byebye(0);
			parseGPS();
		} while(ok!=1 && ret<=7);
		if(ret>7) {
			printf("Too many NAKS in doSAlmanac\n");
			byebye(-1);
		}
	}
	while(sending!=32) {
		almm->wk=-1;
		ret=0;
		do {
			ret++;
			sendGPSMessage(message, 44);
			len=getGPSMessage();
			if(COMtimeout) byebye(0);
			parseGPS();
		} while(ok!=1 && ret<=7);
		if(ret>7) {
			printf("Too many NAKS in doSAlmanac\n");
			byebye(-1);
		}
		sending++;
	}
	sendGPSMessage(almt,4);  /* almanac data terminator */
	len=getGPSMessage();   /* get ack/nak, assume ack */
} /* doSAlmanac */

/* -------------------------------------------------------------------------- */
PROC void doAlmanac()
{
/**** Week 851 almanac for PRN-01 ***********
ID:                          001
Health:                      000
Eccentricity:                3.608226776e-03
Time of Applicability(s):    5.898240000e+05
Orbital Inclination(rad):    9.540965021e-01
Rate of Right Ascen(r/s):   -8.091765626e-09
SQRT(A) (m^1/2):             5.153528809e+03
Right Ascen at TOA(rad):    -7.805333171e-01
Argument of Perigee(rad):   -1.456979147e+00
Mean Anom(rad):              2.899803800e+00
Af0(s):                      6.866455078e-05
Af1(s/s):                    1.382431947e-10
week:                        851
*/

	alm=(struct alm*)(gGarminMessage+3);
	if(alm->wk==-1) return;  /* skip unhealthy sats */
	if(satnum>1) printf("\n");
 printf("**** Week %3d almanac for PRN-%02d ***********\n", alm->wk, satnum);
 printf("%-29s%03d\n","ID:",satnum);
 printf("%-29s%3s\n","Health:",alm->wk==-1?"111":"000");
 printf("%-25s%19.9e\n","Eccentricity:",alm->ecc);
 printf("%-25s%19.9e\n","Time of Applicability(s):",alm->ta);
 printf("%-25s%19.9e\n","Orbital Inclination(rad):",alm->OI);
 printf("%-25s%19.9e\n","Rate of Right Ascen(r/s):",alm->RRA);
 printf("%-25s%19.9e\n","SQRT(A) (m^1/2):",alm->sqrta);
 printf("%-25s%19.9e\n","Right Ascen at TOA(rad):",alm->RA);
 printf("%-25s%19.9e\n","Argument of Perigee(rad):",alm->argper);
 printf("%-25s%19.9e\n","Mean Anom(rad):",alm->meananom);
 printf("%-25s%19.9e\n","Af0(s):",alm->af0);
 printf("%-25s%19.9e\n","Af1(s/s):",alm->af1);
 printf("%-29s%d\n","week:",alm->wk);

} /* doAlmanac */
/* -------------------------------------------------------------------------- */
PROC void sendGPSMessage(BYTE *message, short bytes)
{
	short i;
	int n;
	BYTE csum = 0;
	BYTE *p = gGarminMessage;
	ok=-1;	
	*p++ = 0x10;    /* Start of message */
	for (i=0; i<bytes; i++) {
		*p++ = message[i];
		csum -= message[i];
		if (message[i] == 0x10)
			*p++ = 0x10;
	}
	*p++ = csum;
	if (csum == 0x10)
		*p++ = 0x10;
	*p++ = 0x10;
	*p++ = 0x03;
	n =(int)(p - gGarminMessage);
	AsyncOut(*(gGarminMessage));
	for(i=1;i<n;i++) AsyncOut(*(gGarminMessage+i));
} /* sendGPSMessage() */

/*
 * checksums an incoming GPS record *after* repeating 0x10 characters are
 *  removed
 */
PROC int checksum(unsigned char *m,int l)
{
	int i;
	unsigned char cs;

	cs=0;
	for(i=1;i<l-3;i++) {
		cs-=m[i];
	}
	if(cs==m[l-3]) return 1;
	return 0;
} /* checksum */

PROC void poweroff(void)
{
	sendGPSMessage(pwroff, 4);
	while(AsyncOutStat());
	byebye(0);
} /* poweroff */

PROC void prhex(unsigned char *message,int c)
{
	int i;

	printf("Read %d bytes\n",c);
	for(i=0;i<c;i++) printf("%02x ",message[i]);
	printf("\n");
} /* prhex */

/*
 *	getGPSMessage() returns the number of bytes in the message. If the
 *	timeout period has lapsed without completing a message, 0 is returned.
 */
/* -------------------------------------------------------------------------- */
PROC short getGPSMessage(void)
{
	extern short gInRefNum;
	time_t t;
	BYTE c, *p = gGarminMessage, last = 0;
	
	short length = 0, ne = 0;
	t = time(NULL);
	COMtimeout=0;
	for (;;) {
		if ((time(NULL)-t) > TIMEOUT) {
			COMtimeout=1;
			return 0;
		}
		COMtimeout=0;
		while (AsyncInStat()) {
			if (length >= MAX_LENGTH-1) {
				printf("GPS communication protocol error\n");
				return 0;
			}
			c=AsyncIn();
			t = time(NULL);  /* reset time */

			if(c==0x03 && last==0x10)
				ne = 1;
			else
				ne = 0;
			
			if (c == 0x10 && last == 0x10)
				last = 0;
			else {
				last = *p++ = c;
				++length;
			}

			if (*(p-1) == 0x03 && *(p-2) == 0x10 && ne) {
				GPSchecksum=checksum(gGarminMessage,length);
				return length;
			}
		}
	}
} /* getGPSMessage() */

/*
 * Gets records from the GPS45  recordtype holds the type of record
 *  the program expects to see
 */
PROC void getGPSrecords(unsigned char *m, int c)
{
	int i,nakc;
	(void)getGPSMessage();
	if(COMtimeout) byebye(-1);
	parseGPS();
	if(!numrecords) {
		printf("GPS: No %s records to send\n",
		         recordtype==TRK?"Track":"Waypoint");
		sendGPSMessage(ack1,4);/* send ack of numrecords */
		i=getGPSMessage(); /* get RouteEOF */
		parseGPS();
		byebye(0);
	}
	if(s3o) fwrite(&numrecords,2,1,out);
	nak1[2]=recordtype;
	nakc=0;
	for(i=0;i<numrecords;i++) {
		sendGPSMessage(m,c); /* send next record */
		len=getGPSMessage(); /* get record */
		while(!GPSchecksum) {
			if(++nakc>7) {
				printf("Rcvd too many bad records\n");
				byebye(-2);
			}
			sendGPSMessage(nak1,4);   /* send NAK */
			(void)getGPSMessage(); /* get record */
		}
		nakc=0;
		lastlat=record.la;
		lastlon=-record.lo;
		parseGPS();
	}
} /* getGPSrecords */

PROC void getGPSstart(unsigned char *m, int c)
{
	int ret;
	ret=0;
	do {
		ok=-1;
		ret++;
		sendGPSMessage(m,c);
		(void)getGPSMessage();	/* make sure GPS receiver responded */
		if(COMtimeout) byebye(-1);
		parseGPS();
	} while(ok!=1 && ret<=7);
	if(ret>7) {
		printf("Too many NAKS\n");
		byebye(-1);
	}
/*
 * gps will respond with the first record of the requested data.  Usually a
 *  count of the number to follow.  This is read by getGPSrecords.....
 */
} /* getGPSstart */

PROC void getID(void)
{
	sendGPSMessage(m1,3);	/* id yourself */
	len=getGPSMessage(); 	/* get ack to id yourself */
	parseGPS();		/* parse the returned record */
	len=getGPSMessage();	/* read the id */
	parseGPS();		/* parse the returned record */
} /* getID */

PROC void getProxWaypoints(void)
{
	recordtype=PROX;
	getGPSstart(pwpt1,4);
	getGPSrecords(wpt2,4);
	sendGPSMessage(ack1,4);/* send ack of waypoints */
	(void)getGPSMessage(); /* get ProxWaypointEOF */
	parseGPS();
	if(!ProxWaypointEOF) printf("No Proximity Waypoint EOF received\n");
} /* getProxWaypoints */

PROC void getWaypoints(void)
{
	recordtype=WPT;
	getGPSstart(wpt1,4);
	getGPSrecords(wpt2,4);
	sendGPSMessage(ack1,4);/* send ack of waypoints */
	(void)getGPSMessage(); /* get WaypointEOF */
	parseGPS();
	if(!WaypointEOF) printf("No Waypoint EOF received\n");
	if(total_dist) {
		sum_dist+=track_d;
		if(points>1)
			printf(" Dist: %7.3lf nm, %7.3lf sm, %7.3lf km\n",
			        track_d,track_d*1.15078,track_d*1.852);
		printf(" DSum: %7.3lf nm, %7.3lf sm, %7.3lf km\n",
			sum_dist, sum_dist*1.15078, sum_dist*1.852);
	}
} /* getWaypoints */

PROC void getGPSTime(void)
{
	int c=0;
	gpstimevar=0;
	while(gpstimevar==0) {
		sendGPSMessage(GPStimex,4);	/* ask for time */
		len=getGPSMessage(); 		/* get ack	*/
		len=getGPSMessage();		/* get time	*/
		parseGPS();			/* output time	*/
		if(++c>25) {
			printf(" Unable to read time\n");
			break;
		}
	}
} /* getGPSTime */

PROC void getGPSPosition(void)
{
	int c=0;
	gpsposvar=0;
	while (gpsposvar==0){
		sendGPSMessage(GPSPos,4);	/* ask for position */
		len=getGPSMessage(); 		/* get ack	    */
		parseGPS();			/* parse the ack    */
		len=getGPSMessage();		/* get Position	    */
		parseGPS();
		if(++c>25) {
			printf(" Unable to read position\n");
			break;
		}
	}
} /* getGPSPosition */

PROC void getTrack(void)
{
	recordtype=TRK;
	getGPSstart(trk1,4);
	getGPSrecords(trk2,4);
	sendGPSMessage(ack1,4);/* send ack of track */
	(void)getGPSMessage(); /* get TrackEOF */
	parseGPS();
	if(!TrackEOF) printf("No Track EOF received\n");
	if(total_dist) {
		sum_dist+=track_d;
		if(points>1)
			printf(" Dist: %7.3lf nm, %7.3lf sm, %7.3lf km\n",
			        track_d,track_d*1.15078,track_d*1.852);
		printf(" DSum: %7.3lf nm, %7.3lf sm, %7.3lf km\n",
			sum_dist, sum_dist*1.15078, sum_dist*1.852);
	}
} /* getTrack */

PROC void getRoute(void)
{
	int i,nakc;

	strcpy(tf,"$$azaz$$");
/*
 * ask for routes
 */
	getGPSstart(rte1,4);
/*
 * get number of records to receive
 */
	(void)getGPSMessage();
	parseGPS();
/*
 * is ultimate output to a navigate.exe route file?
 */
	if(navmode) {
		if((tempf=fopen(tf,"w")) == NULL) {
			fprintf(stderr,"Error opening temp file:'%s'\n",tf);
			byebye(0);
		}
	}	
/*
 * the number of records includes all the waypoints plus one for each
 *   route name.  It does not include route end data.  It does not include
 *   the number of waypoints in each route.  The beginning of a new route
 *   signifies the end of the old one.
 */
	if(!numrecords) {
		printf("GPS: No Route records to send\n");
		if(navmode) {
			fclose(tempf);
			unlink(tf);
		}
		sendGPSMessage(ack1,4);/* send ack of numrecords */
		i=getGPSMessage(); /* get RouteEOF */
		parseGPS();
		return;
	}
	recordtype=RTE_WPT;
	nak1[2]=recordtype;
	nakc=0;
	for(i=0;i<numrecords;i++) {
		sendGPSMessage(rte2,4); /* send next route pt */
		(void)getGPSMessage(); /* get route */
		while(!GPSchecksum) {
			if(++nakc>7) {
				printf("Rcvd too many bad records\n");
				byebye(-2);
			}
			sendGPSMessage(nak1,4);   /* send NAK */
			(void)getGPSMessage(); /* get record */
		}
		parseGPS();
	}
	sendGPSMessage(ack1,4);/* send ack of route */
	(void)getGPSMessage(); /* get RouteEOF */
	parseGPS();
	if(!RouteEOF) {
		printf("No Route EOF received\n");
	}
	else {
		if(tmode&&numrecords!=0)
		   	printf("E  %02d\n", record.route_number);
		if(navmode)
			fprintf(tempf,"E  %02d\n", record.route_number);
		record.in_route=0;
	}
/*
 * if the ultimate output is to a navigate.exe route file then we must
 *  read the temp file as if it were the original input.
 */
	if(navmode) {
		fclose(tempf);
		tmode=g6=i80=p4=s3o=sa_merge=0;
		intype=determine_t(tf);
		in=fopen(tf,"r");
		read_text();
		fclose(in);
		fclose(out);
		unlink(tf);
	}
} /* getRoute */

PROC void getAlmanac(void)
{
	getGPSstart(alm1,4);
/* get number of records to receive */
	len=getGPSMessage();
	if(COMtimeout==1) byebye(-1);
	parseGPS();
	if(!numrecords) printf("GPS: No almanac records to send\n");
	for(satnum=1;satnum<=numrecords;satnum++) {
		sendGPSMessage(alm2,4); /* send next almanac */
		len=getGPSMessage(); /* get almanac */
		if(COMtimeout==1) byebye(-1);
		parseGPS();
	}
	sendGPSMessage(ack1,4);/* send ack of almanac */
	(void)getGPSMessage(); /* get AlmanacEOF */
	if(COMtimeout==1) byebye(-1);
	parseGPS();
	if(!AlmanacEOF) printf("No Almanac EOF received\n");
	else printf("\n");
} /* getAlmanac */

/*
 *	@(#)getopt.c	2.2 (smail) 1/26/87
 */

/*
 * Here's something you've all been waiting for:  the AT&T public domain
 * source for getopt(3).  It is the code which was given out at the 1985
 * UNIFORUM conference in Dallas.  I obtained it by electronic mail
 * directly from AT&T.  The people there assure me that it is indeed
 * in the public domain.
 * 
 * There is no manual page.  That is because the one they gave out at
 * UNIFORUM was slightly different from the current System V Release 2
 * manual page.  The difference apparently involved a note about the
 * famous rules 5 and 6, recommending using white space between an option
 * and its first argument, and not grouping options that have arguments.
 * Getopt itself is currently lenient about both of these things White
 * space is allowed, but not mandatory, and the last option in a group can
 * have an argument.  That particular version of the man page evidently
 * has no official existence, and my source at AT&T did not send a copy.
 * The current SVR2 man page reflects the actual behavor of this getopt.
 * However, I am not about to post a copy of anything licensed by AT&T.
 */

/*LINTLIBRARY*/
#ifndef	NULL
#define NULL	0
#endif
#define EOF	(-1)
#define ERR(s, c)	if(opterr){\
	extern int write();\
	char errbuf[2];\
	errbuf[0] = c; errbuf[1] = '\n';\
	(void) write(1, argv[0], (unsigned)strlen(argv[0]));\
	(void) write(1, s, (unsigned)strlen(s));\
	(void) write(1, errbuf, 2);\
	(void) write(1, "g7to -h [I|O|D] for help\n",25);byebye(0);}



PROC int getopt(int argc, char **argv, char *opts)
{
	static int sp = 1;
	register int c;
	register char *cp;

	if(sp == 1)
		if(optind >= argc ||
		   argv[optind][0] != '-' || argv[optind][1] == '\0')
			return(EOF);
		else if(strcmp(argv[optind], "--") == 0) {
			optind++;
			return(EOF);
		}
	optopt = c = argv[optind][sp];
	if(c == ':' || (cp=strchr(opts, c)) == NULL) {
		ERR(": illegal option -- ", c);
		if(argv[optind][++sp] == '\0') {
			optind++;
			sp = 1;
		}
		return('?');
	}
	if(*++cp == ':') {
		if(argv[optind][sp+1] != '\0')
			optarg = &argv[optind++][sp+1];
		else if(++optind >= argc) {
			ERR(": option requires an argument -- ", c);
			sp = 1;
			return('?');
		} else
			optarg = argv[optind++];
		sp = 1;
	} else {
		if(argv[optind][++sp] == '\0') {
			sp = 1;
			optind++;
		}
		optarg = NULL;
	}
	return(c);
} /* getopt */

PROC void Catcher(unsigned dd)
{
	printf("Catcher abort: ");
	switch(dd) {
		case SIGFPE : printf("Floating point trap\n");break;
		case SIGILL : printf("Illegal instruction\n"); break;
		case SIGINT : printf("Break or CNTL-C pressed\n");break;
		case SIGSEGV: printf("Memory access violation\n");break;
		case SIGTERM: printf("Termination signal received\n");break;
		case SIGABRT: printf("Abort signal\n");
		default: printf("Unknown reason\n");
	}
	fflush(stdout);
	byebye(1);	
} /* Catcher */

/*
 * allowable colors: black red blue green yellow
 */
PROC void set_color(void)
{
	int color;
	strupr(optarg);
	switch(optarg[1]) {
		case 'R': color=1; break;
		case 'G': color=3; break;
		case 'Y': color=4; break;
		case 'B': switch(optarg[3]) {
				case 'A': color=0; goto tp;
				case 'U': color=2; goto tp;
			}
		default: Usage(1);
	}
tp:;
	switch(optarg[0]) {
		case 'T': TextColr=color; return;
		case 'O': ObjColor=color; return;
		default: Usage(2);
	}
} /* set_color */
/*
 * allowable sizes:  vl, s, m, l, vl
 */
PROC void set_size(void)
{
	int size;
	
	strupr(optarg);
	switch(optarg[1]) {
		case 'S': size=1; break;
		case 'M': size=2; break;
		case 'L': size=3; break;
		case 'V': switch(optarg[2]) {
				case 'S': size=0; goto tp;
				case 'L': size=4; goto tp;
			}
		default: Usage(3);
	}
tp:;
	switch(optarg[0]) {
		case 'T': TextSize=size; break;
		case 'O': ObjSize=size; break;
		default: Usage(4);
	}
} /* set_size */
/*
 * allowable alignment: NW N NE W E SW S SE
 */
PROC void set_align(void)
{
	strupr(optarg);
	if(strlen(optarg) == 1) 
		switch(optarg[0]) {
			case 'N': TextAlign=1; return;
			case 'E': TextAlign=4; return;
			case 'S': TextAlign=6; return;
			case 'W': TextAlign=3; return;
			default: Usage(5);
		}
	if(strlen(optarg) == 2) 
		switch(optarg[0]) {
			case 'N': if(optarg[1]=='E') {
					TextAlign=2;
					return;
				  }
				  if(optarg[1]=='W') {
				  	TextAlign=0;
					return;
				  }
				  Usage(5);

			case 'S': if(optarg[1]=='E') {
					TextAlign=7;
					return;
				  }
				  if(optarg[1]=='W') {
				  	TextAlign=5;
					return;
				  }
				  Usage(5);
		}
} /* set_align */

/* Convert hex-ascii to integer */
PROC int htoi(char *s)
{
    int i = 0;
    char c;
  
    while((c = *s++) != '\0'){
        if(c == 'x')
            continue;   /* allow 0x notation */
        if('0' <= c && c <= '9')
            i = (i * 16) + (c - '0');
        else if('a' <= c && c <= 'f')
            i = (i * 16) + (c - 'a' + 10);
        else if('A' <= c && c <= 'F')
            i = (i * 16) + (c - 'A' + 10);
        else
            break;
    }
    return i;
} /* htoi */

/* format is port,ioaddr,irq */
PROC void decode_COM(char *b)
{
	char *p;

	trim(b);
	strlwr(b);
	p=strtok(b,",");
	if(p==NULL) Usage(9);
	ComPort=atoi(p);
	ComPort--;
	if(ComPort<0 || ComPort>3) Usage(15);
	p=strtok(NULL,",");
	if(p==NULL) Usage(9);
	if(p[0]=='0' && p[1]=='x') IOaddr=htoi(p);
	else IOaddr=atoi(p);
	p=strtok(NULL,",");
	if(p==NULL) Usage(9);
	IRQnumber=atoi(p);
	if(IRQnumber<3 || IRQnumber>15) Usage(9);
	new_com=1;
} /* decode_COM */

PROC void open_COM(void)
{
	if(ComPort==-1) ComPort=COM1; /* assume COM1 */
	if(ComPort<0 || ComPort>3) Usage(15);
/*
 * safely exit for all SIG's
 */
	signal(SIGABRT,Catcher);
	signal(SIGFPE,Catcher);
	signal(SIGILL,Catcher);
	signal(SIGINT,Catcher);
	signal(SIGSEGV,Catcher);
	signal(SIGTERM,Catcher);
	if(!new_com) switch(ComPort) {
		case COM1: IOaddr=0x3f8; IRQnumber=4; break;
		case COM2: IOaddr=0x2f8; IRQnumber=3; break;
	}
/*
 * running on a HP 100LX/200LX?
 */
	if((lx=get_model())==2) light_sleep(DISABLE);
#define BAUD_RATE	9600
#define	COM_SETTINGS	(BITS_8 | STOP_1 | NO_PARITY)
	AsyncInit(IOaddr,IRQnumber);
	AsyncSet(BAUD_RATE, COM_SETTINGS);
	com_open=1;
} /* open_COM */
/*
 * returns type of input file
 *
 *  1 = gardown7 or txt
 *  2 = GPS45
 *  3 = SA3
 *  4 = Almanac Data
 *  5 = Navigate Route file (*.clg)
 */
PROC int determine_t(char *fname_in)
{
	int rt,magla,maglo;
	double xx,yy;

	numrecords = 0;
	rt=-1;
	if(strncmp(strupr(fname_in),"G45",3) == NULL) {
		if(fname_in[3]=='T') g45type=1;
		if(fname_in[3]=='W') g45type=2;
		if(fname_in[3]=='R') g45type=3;
		if(fname_in[3]=='D') g45type=4;
		if(fname_in[3]=='I') g45type=5;
		if(fname_in[3]=='P') {
			g45type=6;
			interval=atol(&fname_in[4]);
		}
		if(fname_in[3]=='A') g45type=7;
		if(fname_in[3]=='X') g45type=8;
		return 2;
	}

	if((in=fopen(fname_in,"rb")) == NULL) {
		fprintf(stderr,"Error opening input file:'%s'\n",fname_in);
		byebye(0);
	}
/*
 * check for SA3 file
 */
	fread(&filetype,2,1,in);
	if(filetype==0x100)  {
		strcpy(fname_in_SA3,fname_in);
		fclose(in);
		return 3;
	}
/*
 * check for navigate route file
 */
	fread(&filetype,2,1,in);
	if(filetype==0xffff) {
		strcpy(fname_in_NAV,fname_in);
		read_nav_route(0);
		fclose(in);
		return 5;
	}

	if((in=fopen(fname_in,"r")) == NULL) {
		fprintf(stderr,"Error opening input file:'%s'\n",fname_in);
		byebye(0);
	}
	fgets(buf,255,in);
	fseek(in,0,0);
	strcpy(fname_in_txt,fname_in);
	if(strncmp(buf,"****",4) == NULL) return 4;
/*
 * read file to count 'W', 'P' and 'T' records 
 */
	maxlat=-90.0;minlat=90.0;maxlon=-180.0;minlon=180.0;
	while(fgets((char*)bin,255,in) != NULL) {
/*
 * allow reading of proj & g64 files and convert that text format
 *  into standard text format for further processing
 */
		if(bin[3]=='d' && bin[15]=='"') convert_proj(bin);
		if((bin[3] ==0xb0 && bin[16]==0xb0) ||
		   (bin[10]==0xb0 && bin[23]==0xb0)) convert_g64(bin);
		if(((bin[0]=='T') || (bin[0]=='W') || (bin[0]=='P')) &&
		    (bin[1]==' ') && (bin[2]==' ')) {
		    	numrecords++;
			if(bin[0]=='T') numtracks++;
			if(bin[0]=='W') numwaypoints++;
			if(bin[0]=='P') NoProximity++;
			fill_record(bin);
			minlat=min(minlat,record.la);
			maxlat=max(maxlat,record.la);
			minlon=min(minlon,record.lo);
			maxlon=max(maxlon,record.lo);
		}
		if(!record.in_route) {
			if(bin[0]=='R') {
				decode_route_start(bin);
				rtnpts[rt=record.route_number]=0;
				if(rt>259) Usage(16);
				continue;
			}
		}
		else {
			if(bin[0]=='E') {
				record.in_route=0;
				rt=-1;
				continue;
			}
			if(bin[0]=='W' && bin[1]==' ' && bin[2]==' ') {
				rtnpts[rt]++;
			}
		}
	}
/*
 * approximate mag for SA3 output
 */
	magla=maglo=16;
	fclose(in);
	xx=(maxlat-minlat)/2.0;
	rt=17;
	while(--rt>3) {
		if((26500.0/pow(2.0,(double)rt)) > xx*60.0) {
			magla=rt;
			break;
		}
	}
	xx=(maxlat+minlat)/2.0;
	yy=(maxlon-minlon)/2.0;
	rt=17;
	while(--rt>3) {
		if(29800.0/pow(2.0,(double)rt)/(cos(xx*Degree)) > yy*60.0) {
			maglo=rt;
			break;
		}
	}
	setlat=(maxlat+minlat)/2.0;
	setlon=(maxlon+minlon)/2.0;
	setmag=min(magla,maglo);
	if(setmag>16) setmag=16;
	if(setmag<4) setmag=4;
	record.la=0.0;
	record.lo=0.0;
	return 1;
} /* determine_t */

/*
 * returns:   0 - not an HP LX calculator
 *            1 - is an HP95LX
 *            2 - is an HP100LX
 */
PROC int get_model(void)
{

	int HP;
	int model;
	int family;

asm {
	push bx;
	push cx;
	push dx;

	xor bx,bx
	mov ax,4dd4h
	int 15h

	mov HP,bx
	xor ah,ah
	mov al,ch
	mov family,ax
	xor ah,ah
	mov al,cl
	mov model,ax

	pop dx;
	pop cx;
	pop bx;

}
	if(HP!=0x4850) return(0);
	if(family!=1) return(0);
	return model;

} /* get_model */
/*
 * HP100/200LX:  If light sleep is enabled during interrupt driven serial
 *  communications the system *will* eventually crash and burn....turn it off
 *
 * onoff = 0, light sleep disabled
 * onoff = 1, light sleep enabled
 *
 */
PROC void light_sleep(char onoff)
{
    asm {
	mov	ah,0x4e;
	mov	al,onoff;
	int 0x15;
/*
 * we will also turn the rs232 port to the wire
 */
 	mov	ah,0x49;
	mov	al,0;		/* 1 selects IR, 0 selects wire */
	int	0x15;
    }
/*
 * and turn it on or off
 */
 	if(onoff==DISABLE) {   /* turn power off when light sleep is off*/
		asm mov ax,0x4a01;
		asm int 0x15;
	}
	else {			/* turn it on */
		asm mov ax,0x4a00;
		asm int 0x15;
	}
} /* light_sleep */

extern unsigned long RXints,TXints;
extern int RXhw,TXhw,TXoverrun,RXoverrun;

PROC int doasystat(void)
{
       /* printf(" Baud : %lu, I/O Addr: %x, IRQ:%x\n",
		asyp->speed, asyp->addr, asyp->vec); */
        
    printf(" Rcvr Ints: %5lu, Rcvr HiWtr: %3d, Rcvr Overruns: %d\n",
    	     RXints,RXhw,RXoverrun);
    
    printf(" Xmtr Ints: %5lu, Xmtr HiWtr: %3d, Xmtr Overruns: %d\n",
    	     TXints,TXhw,TXoverrun);
    fflush(stdout);
    return 0;
} /* doasystat */

/*
 * strip_chars
 *
 *  Strips spaces and # characters from an input string
 */
PROC void strip_chars(char *s)
{
	int i,o;

	i=o=0;

	for(i=0;i<strlen(s);i++) {
		if(s[i]==' ' || s[i]=='#') continue;
		s[o++]=s[i];
	}
	s[o]=0;
	o=strlen(s);
	if(o<7) return;
	o--;
	s[3]=s[o-2];
	s[4]=s[o-1];
	s[5]=s[o];
	s[6]=0;
} /* strip_chars */

/*
 * reads navigate 1.5 route.clg file
 */
PROC void read_nav_route(int t) /* t=0 just fill route stuff,  =1 do output */
{
	long lat,lon;
	double ll,lo;
	int first_w;
	int NumWaypoints,numroutes,i,j;
	unsigned char dummy[11];
	char Rname_len,Wname_len,Wnote_len;
	char *RouteName=NULL,*WayPointNote=NULL, *WayPointName=NULL;

	if(t==0) for(i=0;i<260;i++) rtnpts[i]=-1;
	fseek(in,0L,0);
 	fread(&numroutes,2,1,in);
/*
 * read route name
 */
 	first_w=1;
 	for(j=1;j<=numroutes;j++) {
		record.in_route=1;
	 	record.route_number=j;
		sprintf(record.rtn," %02d",j);
		if(j==1)
			fread(dummy,10,1,in); /* skip 0xffff,0x0000,4, CRte */
		else
			fread(dummy,2,1,in); /* skip 0x8001 */
		fread(&Rname_len,1,1,in);
	 	if(RouteName != NULL) free(RouteName);
	 	RouteName=(char *)malloc(Rname_len+1);
	 	fread(RouteName,Rname_len,1,in);
		RouteName[Rname_len]=0;
		if(Rname_len>40) RouteName[40]=0;
		strcpy(record.route_comment,RouteName);
		if(t==1 && tog45) doSRoute();
		if(t==1 && tmode) {
			printf("R  %02d %s\n",j,RouteName);
		}

		fread(&NumWaypoints,2,1,in);
		rtnpts[j]=NumWaypoints;
/*
 * read waypoints
 */
		for(i=1;i<=NumWaypoints;i++) {
			if(first_w)
				fread(dummy,10,1,in); /* skip 0xffff,
				                         0x0000,4, CWpt */
			else
				fread(&dummy,2,1,in);  /* skip 0x8003 */
			first_w=0;

			fread(&Wname_len,1,1,in);
	 		if(WayPointName != NULL) free(WayPointName);
	 		WayPointName=(char *)malloc(Wname_len+1);

	 		fread(WayPointName,Wname_len,1,in);
			WayPointName[Wname_len]=0;

			fread(&Wnote_len,1,1,in);
	 		if(WayPointNote != NULL) free(WayPointNote);
	 		WayPointNote=(char *)malloc(Wnote_len+1);

	 		fread(WayPointNote,Wnote_len,1,in);
			WayPointNote[Wnote_len]=0;

	 		fread(&lat,4,1,in);
			fread(&lon,4,1,in);
			ll=(double)lat; record.la=ll/=60000.0;
			lo=(double)lon; record.lo=lo/=60000.0;
			(void)toDMlat(ll);
			(void)toDMlon(-lo);

			strip_chars(WayPointName);

	 		if(Wname_len>6) WayPointName[6]=0;
			strcpy(record.name,WayPointName);
			sprintf(record.name,"%-6s",WayPointName);
/*
 * Comment, up to 40 characters
 */
	 		if(Wnote_len>40) WayPointNote[40]=0;
			strcpy(record.comment, WayPointNote);
			trim(record.comment);
			if(t==0) continue;
		 	if(tog45) doSWaypoint(0);

			if(p4) print_proj_w();
			if(g6) print_g64_w();
			if(i80) print_x80_w();
			if(tmode) print_text_w();
			if(s3o) {
				bin[0]='W';
				sa3out_w();
			}
		}
		if(t==1 && tmode) printf("E  %02d\n",j);
		if(t==1 && tog45) {
			sendGPSMessage(rtet, 4);
			(void)getGPSMessage();
		}
 	
	}
} /* read_nav_route */

PROC void	main(int argc, char **argv)
{
	unsigned char a;
	char *ptr, buffer[80];
	int numrecs, num_merge, num_source;

	for(numrecs=0;numrecs<260;numrecs++) rtnpts[numrecs]=-1;
	gPrefs.offset = 0;	/* gmt offset in hours	*/
	gPrefs.datum = 100;	/* WGS 84		*/

	if(argc<2) Usageh0();

	while ((optchar=getopt(argc,argv,
            "123:a:A:b:B:c:C:DdEeg:G:h:H:L:l:m:M:r:R:s:S:p68nNvVwWI:i:tTo:O:"))!=-1)
	    switch (optchar)
	    {
	    	case '1':	ComPort=COM1; break;
	    	case '2':	ComPort=COM2; break;
	    	case '3':	decode_COM(optarg); break;

	    	case 'a':
		case 'A':	set_align(); break;

		case 'b':
		case 'B': 	ObjCode=atoi(optarg); 
				if(ObjCode<0 || ObjCode>52) Usage(7);
				break;
	    	case 'c':
		case 'C':	set_color(); break;

		case 'd':
		case 'D':	total_dist++; break;

		case 'e':
		case 'E':	nocmdline=1; break;

		case 'g':
		case 'G':	setmag=atoi(optarg); break;

		case 'H':
		case 'h': 	strupr(optarg);
				switch(optarg[0]) {
					case 'I': UsagehI();
					case 'O': UsagehO();
					case 'D': UsagehD();
					default: Usageh0();
				}
	    	case 'i':
	    	case 'I':	intype=determine_t(optarg); input++; break;

		case 'l':
		case 'L':	if(setlat==0.0) setlat=mhr(optarg);
				else setlon=mhr(optarg);
				break;
		
		case 'm':
		case 'M':	sa_merge++;strcpy(sa_mergename,optarg); break;

	    	case 'n':
		case 'N':  	noname++; break;

		case 'O':
	    	case 'o':	strcpy(fname_o_SA3,optarg);
				if(strncmp(strupr(optarg),"G45",3)==NULL) {
					tog45++;
					s3o=0;
					if(optarg[3]=='O') pwr++;
				}
				else {
					s3o++;
					tog45=0;
				}
				p4=g6=i80=0;
				output++;
				break;

	    	case 's':
		case 'S':	set_size(); break;

		case 't':
		case 'T':	p4=g6=i80=0; tmode++; output++; break;

		case 'v':
		case 'V':	doAsyncStat++; break;


		case 'W':
		case 'w':  	nameonly++; break;

		case 'P':
	    	case 'p': 	if(!s3o&&!g6&&!tmode&&!i80&&!navmode) {
					navmode=s3o=g6=tmode=i80=0;
					p4++; output++;
				}
				else printf("-P ignored\n");
				break;

		case 'r':
		case 'R':	if(!s3o&&!g6&&!i80&&!p4) {
					p4=s3o=g6=i80=0;
					navmode++; output++;
					strcpy(fname_o_NAV,optarg);
				}
				else printf("-R ignored\n");
				break;

	    	case '6': 	if(!s3o&&!p4&&!tmode&&!i80) {
					s3o=p4=tmode=i80=0; output++; g6++;
				}
				else printf("-6 ignored\n");
				break;

	    	case '8': 	if(!s3o&&!p4&&!g6&&!tmode) {
	    	        	  	s3o=p4=g6=tmode=0; output++; i80++;
				}
				else printf("-8 ignored\n");
				break;
	}
	if(intype==2 && g45type!=3 && navmode) Usage(17);
	if(tog45) {
		open_COM();
		if(pwr) poweroff();
	}

	if(!input) Usage(11);
	if(!output) tmode++;
 /*
  * open input file
  */
 	switch(intype) {
		case 1:
		case 4: if((in=fopen(fname_in_txt,"r"))==NULL) {
				printf("Can't open file '%s'\n",fname_in_txt);
				byebye(0);
			}
			break;
		case 2: open_COM(); break;

		case 3:
			if(!sa_merge && s3o) Usage(12);
	 	case 5:	if((in=fopen(intype==3?fname_in_SA3:fname_in_NAV,"rb"))==NULL) {
				printf("Can't open file '%s'\n",
				     intype==3?fname_in_SA3:fname_in_NAV);
				byebye(0);
			}
			break;
		default: Usage(11);
	}
	if(s3o) {
		if(intype==5) {
			printf("Navigate route file can't go to SA3 file\n");
			byebye(-1);
		}
		if(g45type==3) {
			printf("GPS 45 Route download can't go to SA3 file\n");
			byebye(-1);
		}
		if((out=fopen(fname_o_SA3,"wb"))==NULL) {
			printf("Can't open output file '%s'\n",fname_o_SA3);
			byebye(0);
		}
/* 
 * write sa3 header info
 */
		fwrite(&Id,2,1,out);
		fwrite(&Const1,4,1,out);
		strcpy(buffer,fname_o_SA3);
		ptr=strtok(buffer,".");
		a=(unsigned char)strlen(ptr);
		fwrite(&a,1,1,out);
		fwrite(ptr,a,1,out);
		if(setlat!=0.0) LatConst=to_diskLL(setlat);
		fwrite(&LatConst,4,1,out);
		if(setlon!=0.0) LonConst=to_diskLL(setlon);
		fwrite(&LonConst,4,1,out);
		if(setmag) MagC=setmag;
		fwrite(&MagC,2,1,out);
		fwrite(&Const2,134,1,out);
		fwrite(&Mapfeatures,2,1,out);
		fwrite(&Const3,8,1,out);
	 	fwrite(&ShowGrids,2,1,out);
		fwrite(&Const4,20,1,out);
	}
	if(!sa_merge) {  /* not merging 2 SA3 files... */
		switch(intype) {
			case 1: if(s3o) fwrite(&numrecords,2,1,out);
				if(navmode) {
					out=fopen(fname_o_NAV,"wb");
				}
				read_text();
				if(navmode) {
					fclose(out);
					if(validNav==0) {
						printf("No valid routes\n");
						unlink(fname_o_NAV);
					}
				}
				if(tog45) {
					sendGPSMessage(trkt, 4);
					(void)getGPSMessage();
				}
				break;
	
			case 2: if(navmode && g45type==3) {
					out=fopen(fname_o_NAV,"wb");
				}
				read_COM();
				if(doAsyncStat) doasystat();
				AsyncStop();
				com_open=0;
				if(navmode && g45type==3) fclose(out);
				break;
	
			case 3:
			case 5: if(s3o) fwrite(&numrecords,2,1,out);
				if(getftime(fileno(in),&ft) != 0) {
				       printf("File time err, File:%s\n",
				           intype==3?fname_in_SA3:fname_in_NAV);
				       byebye(0);
				}
				record.dayofmonth=ft.ft_day;
				record.monthn=ft.ft_month;
				record.year=ft.ft_year+1980;
				record.ht=ft.ft_hour;
				record.mt=ft.ft_min;
				record.st=ft.ft_tsec*2;
				if(intype==3) {
					(void)read_sa3_header(in,fname_in_SA3);
					read_sa3(in);
				}
				else {
					read_nav_route(1);
				}
				break;
			case 4: if(!tog45) {
					printf("Output must be G45\n");
					byebye(-1);
				}
				doSAlmanac();
				break;
			default: Usage(14);
		}
	}
	else { /* merging two sa3 files */
		if((merge=fopen(sa_mergename,"rb")) == NULL) {
			fprintf(stderr,"Error opening SA3 merge file:'%s'\n",
					sa_mergename);
			byebye(0);
		}
		num_source=read_sa3_header(in,fname_in_SA3);
		num_merge=read_sa3_header(merge,sa_mergename);

		numrecs=num_source+num_merge;
		fwrite(&numrecs,2,1,out);

		NumObjs=num_source;
		read_sa3(in);
		fclose(in);
		NumObjs=num_merge;
		read_sa3(merge);
		fclose(merge);
	}
	if(s3o) {
		fwrite(&Trailer,16,1,out);
		fclose(out);
	}
	byebye(0);
} /* main */
