#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <alloc.h>
#include <bios.h>
#include <conio.h>
#include <dir.h>
#include <dos.h>
#include <fcntl.h>
#include <io.h>
#include <math.h>
#include <signal.h>
#include <time.h>
  
extern int Isat;  
#define ASY_MAX 4 

int kbraw(void);
/* In aysnc.c: */
int AsyncInit(int addr, int irq);
int asy_speed(int dev,long bps);
void AsyncStop(void);
void AsyncClear(void);
int AsyncIn(void);
int doasystat(void);
  
unsigned AsyncStat(void);  
void AsyncSet(int Baud, int Control);
void AsyncOut(int dev);
int AsyncOutStat(void);
int AsyncInStat(void);

#define COM1 0
#define COM2 1

#define Pi (double)M_PI

extern	char months[13][4];
extern	char days[7][4];
typedef unsigned char BYTE;

/* Messages declarations */
extern	BYTE m1[],     m2[];
extern	BYTE p1[],     p2[];
extern	BYTE alm1[],   alm2[];
extern	BYTE trk1[],   trk2[];
extern	BYTE wpt1[],   wpt2[];
extern	BYTE rte1[],   rte2[],     rte3[];
extern	BYTE almt[],   rtet[],     trkt[],   wptt[];
extern	BYTE pwroff[], GPStimex[], GPSPos[], HDWare[];

struct RECORD {
	char type;		/* Record Type W,T,R,D,P      	*/
	char name[9];		/* Record name		    	*/
	char ns;		/*  N/S for latitude	    	*/
	double la;		/* latitude   in dd.ddddddd 	*/
	char ew;		/*  E/W for longitude       	*/
	double lo;		/* longitude  in dd.ddddddd 	*/
	char month[4];		/* month of record		*/
	int monthn;		/* month number of record	*/
	char day_week[4];	/* day of week of record	*/
	char datetime[25];	/* date/time string as read	*/
	int dayofmonth;		/* day of month 1-31		*/
	int year;		/* 4 digit year of record	*/
	int ht,mt,st;		/* time of record 		*/
	char comment[40];	/* Comment field 20 max for 45 	*/
	char route_comment[40];	/* route comment if in route	*/
	int dla, mla;		/* Deg & Min for Lat		*/
	int dlo, mlo;		/* Deg & Min for Long		*/
	int tnthsla, tnthslo;	/* tenths of a minute*10000	*/
	double minla,minlo;	/* Lat/Long minutes in decimal	*/
	double secla,seclo;	/* Lat/Long seconds in decimal	*/
	int in_route;		/* processing route		*/
	BYTE route_number;	/* route number if in route	*/
	char rtn[4];		/* ASCII route number		*/
	float ProxDist;		/* Proximity Distance		*/
};

extern struct RECORD record;

struct PREFS{
	short datum;
	long creator;
	double offset;
};

#define MAX_LENGTH 100	/* maximum length of Garmin binary message */
#define MAX_LINE 200	/* data file maximum line length */

/* Garmin message type characters			*/
#define ACK	0x06	/* last record received was ok	*/
#define ALM 	0x1f	/* Almanac record		*/
#define EOFREC  0x0c	/* EOF leadin for transters	*/
#define GPSpos	0x11	/* GPS Position record		*/
#define PROX	0x13	/* GPS Proximity Position record*/
#define MYID	0xff	/* Version/ID record		*/
#define NAK	0x15	/* last record received was bad */
#define NREC	0x1b	/* number of records to receive */
#define RTE_NAM 0x1d	/* Route name record		*/
#define RTE_WPT 0x1e	/* Route waypoint record	*/
#define TIMEREC 0x0e	/* UTC Time record 		*/
#define TRK 	0x22	/* Track record			*/
#define WPT 	0x23	/* Waypoint record		*/

#define	COM1		0
#define	COM2		1
#define	COM3		2
#define	COM4		3

/* Defines for Com Port Paramaters, the second paramater to AsyncSet() */
#define BITS_8          0x03
#define BITS_7          0x02
#define STOP_1          0x00
#define STOP_2          0x04
#define EVEN_PARITY     0x18
#define ODD_PARITY      0x08
#define NO_PARITY       0x00

/* Defines for AsyncHand() */
#define	DTR		0x01
#define	RTS		0x02
#define	USER		0x04
#define	LOOPBACK	0x10

/* Defines for AsyncStat() */
#define	D_CTS		0x0100
#define	D_DSR		0x0200
#define	D_RI		0x0400
#define	D_DCD		0x0800
#define	CTS		0x1000
#define	DSR		0x2000
#define	RI		0x4000
#define	DCD		0x8000
#define	PARITY		0x0004
#define	THREMPTY	0x0020
#define	BREAKDET	0x1000

void	Catcher(unsigned dd);
void	Usage(int i);
void	Usageh0(void);
void	UsagehD(void);
void	UsagehI(void);
void	UsagehO(void);
void	byebye(int rt);
int	checksum(unsigned char *m,int l);
void	chk_cmdline(void);
void	convert_g64(unsigned char *in);
void	convert_proj(unsigned char *in);
long	date2days(short mm, short dd, short yy);
void	days2date(long days, short *mm, short *dd, short *yy);
void	decode_COM(char *b);
int	decode_month(char *s);
void	decode_route_end(unsigned char *in);
int	decode_route_start(unsigned char *ix);
int	determine_t(char *fname_in);
double	distance(void);
void	doAlmanac(void);
void	doEOFRec(void);
void	doGPSPos(void);
void	doID(void);
void	doRouteName(void);
void	doSAlmanac(void);
void	doSRoute(void);
void	doSTrack(void);
void	doSWaypoint(int Prox);
void	doTime(void);
void	doTrack(void);
void	doWaypoint(void);
void	doProxWaypoint(void);
void	do_command(unsigned char *b);
int	doasystat(void);
int	dow( int day, int mon, int year );
long	dt2secs(short offset);
void	fill_record(unsigned char *ix);
void	fixname(int j,unsigned char *name);
double	fm_diskLL(unsigned long l);
void	g64(unsigned char *s);
void	getAlmanac(void);
short	getGPSMessage(void);
void	getGPSPosition(void);
void	getGPSTime(void);
void	getGPSrecords(unsigned char *m, int c);
void	getGPSstart(unsigned char *m, int c);
void	getID(void);
void	getRoute(void);
void	getTrack(void);
void	getProxWaypoints(void);
void	getWaypoints(void);
int	get_model(void);
int	getopt(int argc, char **argv, char *opts);
int	htoi(char *s);
void	light_sleep(char onoff);
char *  ltrim(char *s);
void	main(int argc, char **argv);
double	mhr(char * tt);
void	navSRouteS(void);
void	navSWaypoint(void);
char *  null_newline(char *s);
void	open_COM(void);
void	out_sa3_m(void);
void	out_sa3_s(void);
void	out_sa3_t(void);
void	parseGPS(void);
void	poweroff(void);
void	prhex(unsigned char *message,int c);
void	print_g64_t(void);
void	print_g64_w(void);
void	print_proj_t(void);
void	print_proj_w(void);
void	print_text_w(void);
void	print_x80_t(void);
void	print_x80_w(void);
void	proj(unsigned char *s);
void	readMapNote(FILE *in);
void	readSymbol(FILE *in);
void	readText(FILE *in);
void	read_COM(void);
void	read_nav_route(int t) /* t=0 just fill route stuff,  =1 do output */;
void	read_sa3(FILE *in);
int	read_sa3_header(FILE *in, char* fname_in);
void	read_text(void);
char *  rtrim(char *s);
void	sa3out(unsigned char *s);
void	sa3out_w(void);
char *  secs2dt(long secs, short offset);
void	sendGPSMessage(BYTE *message, short bytes);
void	send_num_points(unsigned num);
void	set_align(void);
void	set_color(void);
void	set_size(void);
void	strip_chars(char *s);
unsigned long to_diskLL(double l);
char *  toDMlat(double a);
char *  toDMlon(double a);
char *  trim(char *s);
void	x80(unsigned char *s);
